package com.justep.filebrowser.adapter;

import android.content.Context;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import com.justep.filebrowser.common.IFileItemClickListener;
import com.justep.filebrowser.model.FileInfoData;

import java.util.List;

/**
 * Created by mjm on 16-7-16.
 * modify by lihong on 16-10-21
 */
public abstract class BaseAdapter<T extends RecyclerView.ViewHolder> extends RecyclerView.Adapter<T> {
  protected Context mContext;
  protected List<FileInfoData> mData;
  protected LayoutInflater mInflater;
  //Event Related
  protected IFileItemClickListener mFileItemClickListener;

  public BaseAdapter(Context context, List<FileInfoData> data) {
      this.mContext = context;
      this.mData = data;
      this.mInflater = LayoutInflater.from(context);
  }

  @Override
  public abstract T onCreateViewHolder(ViewGroup parent, int viewType);

  @Override
  public void onBindViewHolder(T holder, int position) {
      setContentView(holder, position);
      initEvent(holder, position);
  }

  public void setOnItemClickListener(IFileItemClickListener listener) {
      this.mFileItemClickListener = listener;
  }

  protected abstract void initEvent(T holder, int position);
  protected abstract void setContentView(T holder, int position);
}
