package com.justep.filebrowser.adapter;

/**
 * Created by lihong on 16/10/10.
 */

import android.content.Context;
import android.support.v7.widget.RecyclerView;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import com.justep.filebrowser.R;
import com.justep.filebrowser.common.ISelectInfo;
import com.justep.filebrowser.common.Utils;
import com.justep.filebrowser.model.FileInfoData;

import java.util.List;

public class FolderSelectAdapter extends BaseAdapter<FolderSelectAdapter.FileViewHolder> {
  private ISelectInfo iSelectInfo;

  public FolderSelectAdapter(Context context, List<FileInfoData> data, ISelectInfo iSelectInfo) {
    super(context, data);
    this.iSelectInfo = iSelectInfo;
  }

  @Override
  public FileViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
		View view = mInflater.inflate(R.layout.chooser_list_item, parent, false);
		return new FileViewHolder(view);
  }

	protected void initEvent(final FileViewHolder holder, final int position) {
		holder.mLayoutContent.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
        if(mFileItemClickListener == null || iSelectInfo == null) {
          return;
        }

        int curposition = holder.getLayoutPosition();
        FileInfoData data = mData.get(curposition);
        if(!data.isDir) {
          holder.changeChecked();
          if(holder.mChevron.getVisibility() == View.VISIBLE){
            iSelectInfo.setSelectedState(data.path, true);
          }else{
            iSelectInfo.setSelectedState(data.path, false);
          }
          return;
        }
        mFileItemClickListener.onClick(v, curposition);
        return;
			}
		});
	}

	@Override
	public void onBindViewHolder(final FileViewHolder holder, int position) {
		setContentView(holder, holder.getLayoutPosition());
		holder.mLayoutContent.setBackgroundResource(R.drawable.recycler_bg);
		initEvent(holder, holder.getLayoutPosition());
	}

		@Override
  public int getItemCount() {
    return mData.size();
  }

  class FileViewHolder extends RecyclerView.ViewHolder{
      public TextView mTvName;
      public ImageView mIvIcon;
      public TextView mTvInfo;
      public ImageView mChevron;

      public View mLayoutContent;

      public FileViewHolder(View itemView) {
        super(itemView);
        mTvName = (TextView) itemView.findViewById(R.id.list_item_tv_name);
        mIvIcon = (ImageView) itemView.findViewById(R.id.list_item_icon);
        mTvInfo = (TextView) itemView.findViewById(R.id.list_item_tv_info);
        mChevron = (ImageView) itemView.findViewById(R.id.chevron);
        mLayoutContent = (ViewGroup) itemView.findViewById(R.id.layout_content);
      }

		  public RecyclerView.ViewHolder changeChecked(){
			  if(mChevron.getVisibility() == View.INVISIBLE) {
          if(!iSelectInfo.isMaxSelected()) {
            mChevron.setVisibility(View.VISIBLE);
          }
			  }else{
				  mChevron.setVisibility(View.INVISIBLE);
			  }
			  return this;
		  }
  }

	protected void setContentView(FileViewHolder holder, int position) {
      FileInfoData data = mData.get(position);
      holder.mTvName.setText(data.name);
      if(data.isDir) {
        holder.mTvInfo.setText(data.subCount + "项  " + data.strModDate);
        //holder.mIvIcon.setBackgroundResource(R.drawable.round_blue);
        holder.mIvIcon.setImageResource(R.mipmap.ic_folder);
        holder.mChevron.setImageResource(R.mipmap.ic_arrow);
        holder.mChevron.setVisibility(View.VISIBLE);
      }else {
        holder.mChevron.setImageResource(R.mipmap.ic_check);
        if(iSelectInfo != null && iSelectInfo.isSelected(data.path)) {
          holder.mChevron.setVisibility(View.VISIBLE);
        } else {
          holder.mChevron.setVisibility(View.INVISIBLE);
        }

        holder.mTvInfo.setText(data.size + " " + data.strModDate);
        if (data.type == FileInfoData.FileType_DOC) {
          //holder.mIvIcon.setBackgroundResource(R.drawable.round_gray);
          holder.mIvIcon.setImageResource(R.mipmap.ic_word);
        } else if (data.type == FileInfoData.FileType_OTHER) {
          //holder.mIvIcon.setBackgroundResource(R.drawable.round_gray);
          holder.mIvIcon.setImageResource(R.mipmap.ic_default);
        } else if (data.type == FileInfoData.FileType_PICTURE) {
          //holder.mIvIcon.setBackgroundResource(R.drawable.round_gray);
          holder.mIvIcon.setImageResource(R.mipmap.ic_picture);
        } else if (data.type == FileInfoData.FileType_MUSIC) {
          //holder.mIvIcon.setBackgroundResource(R.drawable.round_gray);
          holder.mIvIcon.setImageResource(R.mipmap.ic_music);
        } else if (data.type == FileInfoData.FileType_MOVIE) {
          //holder.mIvIcon.setBackgroundResource(R.drawable.round_gray);
          holder.mIvIcon.setImageResource(R.mipmap.ic_movie);
        } else {
          //holder.mIvIcon.setBackgroundResource(R.drawable.round_gray);
          holder.mIvIcon.setImageResource(R.mipmap.ic_default);
        }
      }
  }
}
