package com.justep.filebrowser.adapter;

/**
 * Created by lihong on 16/10/10.
 */


import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.justep.filebrowser.R;

public class ListPopupWindowAdapter extends BaseAdapter {
  private MyMenuItem[] mItems;
  private Context mContext;

  public ListPopupWindowAdapter(MyMenuItem[] list, Context context) {
    super();
    this.mItems = list;
    this.mContext = context;
  }

  @Override
  public int getCount() {
    if (mItems == null) {
      return 0;
    } else {
      return this.mItems.length;
    }
  }

  @Override
  public Object getItem(int position) {
    if (mItems == null) {
      return null;
    } else {
      return this.mItems[position];
    }
  }

  @Override
  public long getItemId(int position) {
    return position;
  }

  @Override
  public View getView(final int position, View convertView, ViewGroup parent) {
    ViewHolder holder = null;
    if (convertView == null) {
      holder = new ViewHolder();
      convertView = LayoutInflater.from(mContext).inflate(R.layout.sort_menu, null, false);
      holder.itemTextView = (TextView) convertView.findViewById(R.id.itemTextView);
      holder.itemIcon = (ImageView)convertView.findViewById(R.id.itemIcon);
      convertView.setTag(holder);
    } else {
      holder = (ViewHolder) convertView.getTag();
    }

    if (this.mItems != null) {
      final MyMenuItem item = this.mItems[position];//.get(position);
      if (holder.itemTextView != null) {
        holder.itemTextView.setText(item.text);
        holder.itemIcon.setImageResource(item.imageId);
      }
    }

    return convertView;

  }

  private class ViewHolder {
    TextView itemTextView;
    ImageView itemIcon;
  }

}
