package com.justep.filebrowser.fragment;

/**
 * Created by lihong on 16-10-12.
 */

import android.app.Activity;
import android.view.View;

import com.justep.filebrowser.adapter.BaseAdapter;
import com.justep.filebrowser.adapter.FolderSelectAdapter;
import com.justep.filebrowser.common.ISelectInfo;
import com.justep.filebrowser.model.FileInfoData;
import com.justep.filebrowser.model.FolderData;


import java.io.File;
import java.util.List;

public class DirSelectFragment extends ListFragment {
  private int mCurSortType = 0;
  private FolderData mFolder;
  ISelectInfo mISelectInfo;

  public DirSelectFragment(Activity activity, ISelectInfo iselectInfo, String mLabel) {
    super(mLabel);
    mFolder = new FolderData(mLabel, false);
    mFolder.updateFolderInfos(mCurSortType, false);
    mISelectInfo = iselectInfo;
  }

  @Override
  protected BaseAdapter newAdapter(Activity activity, List<FileInfoData> infoList) {
      return new FolderSelectAdapter(activity, infoList, mISelectInfo);
  }

  @Override
  protected void onItemClick(View v, int position) {
    FileInfoData data = mFileInfoList.get(position);
    if(data == null){
      return;
    }

    File file = new File(data.path);
    if(file.isDirectory()) {
      SelectFragmentStackManager.getInstance().switchFragment(mActivity, data.path);
      return;
    }
  }

  protected void onItemLongClick(int action, int position){

  }

  protected void onItemDeleteCilck(View view, int position){

  }

  @Override
  protected List<FileInfoData> getData() {
    List<FileInfoData> list = mFolder.getFolderInfos();
    return list;
  }

  @Override
  public void onDestroy() {
    super.onDestroy();
    mFolder.clear();
  }

}
