package com.justep.filebrowser.fragment;

/**
 * modify by lihong on 16/10/10.
 */

import android.app.Activity;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.view.View;
import android.view.ViewGroup;


import com.justep.filebrowser.R;
import com.justep.filebrowser.adapter.BaseAdapter;
import com.justep.filebrowser.common.IFileItemClickListener;
import com.justep.filebrowser.model.FileInfoData;

import java.util.List;


public abstract class ListFragment extends BaseFragment {
    protected RecyclerView mRvRootDir;
    protected BaseAdapter mAdapter;
    protected List<FileInfoData> mFileInfoList;
    private ViewGroup mEmptyFolderView;

    public ListFragment(String mLabel) {
        super(mLabel);
    }

    @Override
    public View initViews() {
      mFileInfoList = getData();
      View view = View.inflate(mActivity, R.layout.fragment_recyler_view, null);
      mRvRootDir = (RecyclerView) view.findViewById(R.id.folder_recylerview);
      mEmptyFolderView = (ViewGroup) view.findViewById(R.id.emptyFolderLayout);
      updateView();
      return view;
    }

    @Override
    public void initData() {
        super.initData();
        if(mRvRootDir != null) {
          mAdapter = newAdapter(mActivity, mFileInfoList);
          mRvRootDir.setAdapter(mAdapter);
          mRvRootDir.setLayoutManager(new LinearLayoutManager(mActivity));
          mAdapter.setOnItemClickListener(new IFileItemClickListener() {
                @Override
                public void onClick(View v, final int position) {
                    onItemClick(v, position);
                }

                @Override
                public void onLongClick(int action, final int position) {
                    onItemLongClick(action, position);
                }

                @Override
                public void onDeleteBtnCilck(View v, int position){
                    onItemDeleteCilck(v, position);
                }

            });
        }
    }

    public void updateView(){
      if(mFileInfoList != null && mFileInfoList.size() > 0) {
        mRvRootDir.setVisibility(View.VISIBLE);
        mEmptyFolderView.setVisibility(View.GONE);
      }else{
        mRvRootDir.setVisibility(View.GONE);
        mEmptyFolderView.setVisibility(View.VISIBLE);
      }
    }

  protected abstract BaseAdapter newAdapter(Activity activity, List<FileInfoData> fileInfo);

  protected List<FileInfoData> getFileInfo() {
      return mFileInfoList;
  }

  protected abstract void onItemClick(View v, int position);

  protected abstract void onItemLongClick(int action, int position);

  protected abstract void onItemDeleteCilck(View view, int position);

  protected abstract List<FileInfoData> getData();
}
