package com.justep.filebrowser.fragment;

/**
 * Created by lihong on 16/10/10.
 */

import android.app.Activity;
import android.support.v4.app.FragmentTransaction;


import com.justep.filebrowser.R;
import com.justep.filebrowser.common.IRefreshView;
import com.justep.filebrowser.common.ISelectInfo;
import com.justep.filebrowser.global.FilePath;


public class SelectFragmentStackManager {
  private static SelectFragmentStackManager sManager;

  private FragmentStack mFragmentStack;
  private android.support.v4.app.FragmentManager mFragmentManager;
  private IRefreshView mRefreshView;
  private ISelectInfo mSelectInfo;
  private int mRootIndex;

  private SelectFragmentStackManager(android.support.v4.app.FragmentManager fm, IRefreshView iRefresh, ISelectInfo iselectInfo) {
    mFragmentStack = new FragmentStack();
    this.mFragmentManager = fm;
    this.mRefreshView = iRefresh;
    mSelectInfo = iselectInfo;
    if(sManager == null){
      sManager = this;
    }
  }

  private SelectFragmentStackManager() {
    mFragmentStack = new FragmentStack();
    if(sManager == null){
      sManager = this;
    }
  }
  public synchronized static SelectFragmentStackManager getInstance(android.support.v4.app.FragmentManager fm, IRefreshView iRefresh, ISelectInfo iselectInfo) {
    if(sManager == null) {
      sManager = new SelectFragmentStackManager(fm, iRefresh, iselectInfo);
    }
    return sManager;
  }


  public synchronized static SelectFragmentStackManager getInstance() {
    if(sManager == null) {
      sManager = new SelectFragmentStackManager();
    }
    return sManager;
  }

  public void switchFragment(Activity activity, String label) {
    BaseFragment fragment = null;
    FragmentTransaction ft = mFragmentManager.beginTransaction();

    if(!mFragmentStack.hasFragment(label)) {
      fragment = new DirSelectFragment(activity, mSelectInfo, label);
      mFragmentStack.push(fragment);

      if(!label.equals(FilePath.ROOT_DIR)){
        ft.setCustomAnimations(
          R.anim.push_left_in,
          R.anim.push_left_out,
          R.anim.back_left_in,
          R.anim.back_right_out);
        ft.replace(R.id.forldView, fragment, label);
        ft.addToBackStack(null);
        ft.commit();
      }else {
        ft.replace(R.id.forldView, fragment, label);
        ft.addToBackStack(null);
        mRootIndex = ft.commit();
      }
    }
    mFragmentStack.printData();
    label = fragment.getLabel();
    mRefreshView.refreshInfo(label);
  }

  public void goHomeFragment() {
    BaseFragment fragment = null;
    String path = getPeek();
    while(!path.equals(FilePath.ROOT_DIR)){
      mFragmentStack.pop();
      path = getPeek();
    }

    fragment = mFragmentStack.peek();
    mFragmentStack.clear();
    mFragmentStack.push(fragment);
    mFragmentStack.printData();
    mFragmentManager.popBackStack(mRootIndex, 0);
    mRefreshView.refreshInfo(FilePath.ROOT_DIR);
  }

  public void clear() {
    mFragmentStack.clear();
    sManager = null;
  }

  public String getPeek() {
    return mFragmentStack.peek().getLabel();
  }

  public void removeTop() {
    mFragmentStack.pop();
    BaseFragment fragment = mFragmentStack.peek();
    mRefreshView.refreshInfo(fragment.getLabel());
    int count = mFragmentManager.getBackStackEntryCount();
    if(count > 0) {
      mFragmentManager.popBackStack();
    }
  }
}
