package com.justep.filebrowser.model;

/**
 * Created by lihong on 16/10/11.
 */

import java.util.Date;

public class FileInfoData {
    public boolean isDir;
    public int subCount;
    public String path;
    public String name;
    public int type;
    public String size;
    public long nSize;
    public String strModDate;
    public Date modDate;
    public int tag;

    public static final int FileType_TXT = 100;
    public static final int FileType_DOC = 101;
    public static final int FileType_PDF = 102;
    public static final int FileType_PICTURE = 103;
    public static final int FileType_MOVIE = 104;
    public static final int FileType_MUSIC = 105;
    public static final int FileType_ZIP = 106;
    public static final int FileType_OTHER = 107;
    public static final int FileType_PICTURANDEMOVIE = 108;


    public FileInfoData() {
      isDir = false;
      subCount = 0;
      path = "";
      name = "";
      size = "";
      nSize = 0;
      strModDate = "";
      modDate = new Date();
      tag = 0;
    }

    public FileInfoData(String name, String path, String size, int type, String date,
                    boolean isDir, int fileCount) {
        this.name = name;
        this.path = path;
        this.size = size;
        this.type = type;
        this.strModDate = date;
        this.isDir = isDir;
        this.subCount = fileCount;
    }

    @Override
    public String toString() {
        return "FileInfo{" +
                "name='" + name + '\'' +
                ", path='" + path + '\'' +
                ", size='" + size + '\'' +
                ", type=" + type +
                ", date='" + strModDate + '\'' +
                ", isDir=" + isDir +
                ", fileCount=" + subCount +
                '}';
    }
}
