//
//  FileChooseViewController.m
//  FileBrowser
//
//  Created by leeh on 16/9/6.
//  Copyright © 2016年 leeh. All rights reserved.
//

#import "FileChooseViewController.h"
#import "FileInfoData.h"
#import "FolderData.h"
#import "UITableView+WLEmptyPlaceHolder.h"


#define TABLEVIEW_ROW_HIGHT 50.0f

@interface FileChooseViewController (){
  FolderData* folder;
  NSString *curparentDir;
  UIButton *backButton;
  UIButton *sendButton;
  UIView* emptyView;
  UITableView *tableView;
}

@end

@implementation FileChooseViewController


static NSMutableArray* curChooseFiles = nil;

#pragma mark - choosefiles operate
+ (NSArray *)getFiles{
  NSArray* retFiles = [curChooseFiles copy];
  curChooseFiles = nil;
  return retFiles;
}

+(bool)addChooseFile:(NSString*)pathname
      maxSelectCount:(NSUInteger)maxSelectCount{
  if(curChooseFiles == nil){
    curChooseFiles = [NSMutableArray array];
  }
  
  if([curChooseFiles count] <= maxSelectCount){
    [curChooseFiles addObject:pathname];
    return true;
  }
  return false;
}

+(bool)removeChooseFile:(NSString*)pathname{
  if(curChooseFiles == nil){
    return true;
  }
  
  for(NSString* name in curChooseFiles)
  {
    if([name isEqualToString:pathname]){
      [curChooseFiles removeObject:name];
      return true;
    }
  }
  return false;
}

+(bool) choosedFile:(NSString*)pathname{
  if(curChooseFiles == nil){
    return false;
  }
  
  for(NSString* name in curChooseFiles)
  {
    if([name isEqualToString:pathname]){
      return true;
    }
  }
  return false;
}

+(NSUInteger) getChooseFilesCount{
  if(curChooseFiles == nil){
    return 0;
  }
  return [curChooseFiles count];
}


#pragma mark - choosefiles operate

-(void)buttonTouchDownClick:(UIButton *)sender{ 
  UIColor* orgColor = sender.backgroundColor;
  sender.backgroundColor = [UIColor colorWithRed:0.8 green:0.8 blue:0.8 alpha:0.3];
  [sender setTitleColor:[UIColor colorWithRed:0.157 green:0.686 blue:0.973 alpha:1] forState:UIControlStateNormal];
  dispatch_after (dispatch_time (DISPATCH_TIME_NOW, (int64_t )(0.2 * NSEC_PER_SEC )), dispatch_get_main_queue (), ^{
    sender.backgroundColor = orgColor;
    [sender setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
  });
}

- (void)compeleteChooseFile:(UIButton *)sender{
    if(_pickerDelegate != nil){
        [_pickerDelegate selected:curChooseFiles];
    }else{
        [_pickerDelegate cancelSelect];
    }
    [curChooseFiles removeAllObjects];
}

- (void)backClick:(UIButton *)sender{
  if(_pickerDelegate != nil){
    [_pickerDelegate cancelSelect];
  }
  [curChooseFiles removeAllObjects];
}

-(void)refreshSendButton{
  unsigned long count = [FileChooseViewController getChooseFilesCount];
  
  NSString* caption = @"发送";
  if(_retLabelTitle && _retLabelTitle.length > 0){
    caption = [NSString stringWithString:_retLabelTitle];
  }
  
  if(count > 0){
    NSString* strTitle = [NSString stringWithFormat:@"%@(%lu/%lu)", caption, count, (unsigned long)_maxSelectCount];
    [sendButton setTitle:strTitle forState:UIControlStateNormal];
    [sendButton setEnabled:YES];
  }else{
    [sendButton setEnabled:NO];
    [sendButton setTitle:caption forState:UIControlStateNormal];
  }
  [sendButton setHidden:NO];
}

- (id)initWithPath:(NSString *)path
         parentDir:(NSString*)parentDir{
  self = [super init];
  if(self) {
    
    self->tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height) style:UITableViewStylePlain];
    self->tableView.rowHeight = 70;
    self->tableView.tableFooterView = [[UIView alloc] init];
    self->tableView.dataSource = self;
    self->tableView.delegate = self;
   
    self->tableView.separatorInset = UIEdgeInsetsMake(0, 0, 0, 5);
    self->tableView.separatorStyle = UITableViewCellSeparatorStyleSingleLine;
    
    [self.view addSubview:self->tableView];

    _maxSelectCount = 9;
    
    curparentDir = parentDir;
    folder = [[FolderData alloc] initWithPath:path
              isSearch:false];
    [folder updateFolderInfos:0];
    
//    sendButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
//    sendButton.frame = CGRectMake(0, 0, 80, 30);
//    sendButton.backgroundColor = [UIColor clearColor];//colorWithRed:0 green:172.0/255.0 blue:59.0/255.0 alpha:1];
//    sendButton.layer.cornerRadius = 4.0;
//    //sendButton.layer.borderWidth = 0.3f;
//    sendButton.contentHorizontalAlignment = UIControlContentHorizontalAlignmentRight;
//    [sendButton setHidden:YES];
//    
//    CGColorSpaceRef colorSpace = CGColorSpaceCreateDeviceRGB();
//    CGColorRef colorref = CGColorCreate(colorSpace,(CGFloat[]){ 0.157, 0.686, 0.973, 1 });
//    [sendButton.layer setBorderColor:colorref];//边框颜色
//    //sendButton.layer.borderWidth = 0.3f;
//    
//    [sendButton setTitleColor:[UIColor colorWithRed:0.157 green:0.686 blue:0.973 alpha:1] forState:UIControlStateNormal];
//    [sendButton addTarget:self action:@selector(compeleteChooseFile:) forControlEvents:UIControlEventTouchUpInside];
//    [sendButton addTarget:self action:@selector(buttonTouchDownClick:) forControlEvents:UIControlEventTouchDown];
//    
//    UIBarButtonItem *sendItem = [[UIBarButtonItem alloc] initWithCustomView:sendButton];
    
    
    backButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
    backButton.frame = CGRectMake(0, 0, 40, 30);
    backButton.backgroundColor = [UIColor clearColor];//colorWithRed:0 green:172.0/255.0 blue:59.0/255.0 alpha:1];
    backButton.layer.cornerRadius = 5.0;
    
    //[backButton.layer setBorderColor:colorref];//边框颜色
    //backButton.layer.borderWidth = 0.3f;
    
    [backButton setTitle:@"取消" forState:UIControlStateNormal];
    
    [backButton setTitleColor:[UIColor colorWithRed:0.157 green:0.686 blue:0.973 alpha:1] forState:UIControlStateNormal];
    [backButton addTarget:self action:@selector(backClick:) forControlEvents:UIControlEventTouchUpInside];
    [backButton addTarget:self action:@selector(buttonTouchDownClick:) forControlEvents:UIControlEventTouchDown];
    
    UIBarButtonItem *backBtnItem = [[UIBarButtonItem alloc] initWithCustomView:backButton];
    
    UIBarButtonItem *negativeSpacer = [[UIBarButtonItem alloc]
                                       initWithBarButtonSystemItem:UIBarButtonSystemItemFixedSpace
                                       target:nil action:nil];
    /**
     *  width为负数时，相当于btn向右移动width数值个像素，由于按钮本身和边界间距为5pix，所以width设为-5时，间距正好调整
     *  为0；width为正数时，正好相反，相当于往左移动width数值个像素
     */
    negativeSpacer.width = -10.0f;
    self.navigationItem.rightBarButtonItems = @[negativeSpacer, backBtnItem];
    NSString* title = [path lastPathComponent];
    if(![title isEqualToString:@"Documents"]){
      self.navigationItem.title = [path lastPathComponent];
    }
    
    UIView *bottomToolBar = [[UIView alloc] initWithFrame:CGRectMake(0, self.view.frame.size.height - 50, self.view.frame.size.width, 50)];
    CGFloat rgb = 253 / 255.0;
    bottomToolBar.backgroundColor = [UIColor colorWithRed:rgb green:rgb blue:rgb alpha:1.0];
    
    sendButton = [UIButton buttonWithType:UIButtonTypeCustom];
    sendButton.frame = CGRectMake(self.view.frame.size.width - 80 - 12, 3, 80, 44);
    sendButton.contentHorizontalAlignment = UIControlContentHorizontalAlignmentRight;
    sendButton.titleLabel.font = [UIFont systemFontOfSize:16];
    [sendButton addTarget:self action:@selector(compeleteChooseFile:) forControlEvents:UIControlEventTouchUpInside];
    //[sendButton setTitle:@"发送" forState:UIControlStateNormal];
    //[sendButton setTitle:@"发送" forState:UIControlStateDisabled];
    [sendButton setTitleColor:[UIColor colorWithRed:0.157 green:0.686 blue:0.973 alpha:1.0] forState:UIControlStateNormal];
    [sendButton setTitleColor:[UIColor colorWithRed:0.157 green:0.686 blue:0.973 alpha:0.5] forState:UIControlStateDisabled];
    sendButton.enabled = [FileChooseViewController getChooseFilesCount];
    [sendButton setHidden:NO];
    
    
    UIView *divide = [[UIView alloc] init];
    CGFloat rgb2 = 222 / 255.0;
    divide.backgroundColor = [UIColor colorWithRed:rgb2 green:rgb2 blue:rgb2 alpha:1.0];
    divide.frame = CGRectMake(0, 0, self.view.frame.size.width, 1);
    
    [bottomToolBar addSubview:divide];
    [bottomToolBar addSubview:sendButton];
    [self.view addSubview:bottomToolBar];
    
    CGRect frame = self->tableView.frame;
    NSUInteger count = [folder getFileCount];
    if(count * 70 > frame.size.height - 50){
      UIEdgeInsets insets = self->tableView.contentInset;
      self->tableView.contentInset = UIEdgeInsetsMake(insets.top, insets.left, insets.bottom + 49, insets.right);
    }
    return self;
  }
  return nil;
}

- (void)setPath:(NSString *)path {
  [folder setPath:path];

  [self->tableView reloadData];
}

- (void)viewDidLoad {
  [super viewDidLoad];
  //self->tableView.tableFooterView = [UIView new];
}

- (void)viewWillAppear:(BOOL)animated{
  [super viewWillAppear:animated];
  [self refreshSendButton];
}

- (void)didReceiveMemoryWarning {
  [super didReceiveMemoryWarning];
  // Dispose of any resources that can be recreated.
}

#pragma mark - UITableViewDelegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
  //判断是文件还是文件夹，如果是文件夹，则进入下一级，如果是文件，将改变选中状态
  FileInfoData* data = [folder getFileInfoOfIndex:indexPath.row];
  NSString* pathname = [folder getPathNameOfIndex:indexPath.row];
  if([data isDir]){
    FileChooseViewController *browser = [[FileChooseViewController alloc] initWithPath:pathname
                                                                             parentDir:[pathname lastPathComponent]];
    browser.pickerDelegate = _pickerDelegate;
    
    NSString* backName = [curparentDir lastPathComponent];
    UIBarButtonItem *backItem = [[UIBarButtonItem alloc] initWithTitle:backName style:UIBarButtonItemStylePlain target:nil action:nil];
    [self.navigationItem setBackBarButtonItem:backItem];
    
    [self.navigationController pushViewController:browser animated:YES];
      
    return;
  }
  
  UITableViewCell *cell = [self->tableView cellForRowAtIndexPath:indexPath];
  if(cell.accessoryType == UITableViewCellAccessoryNone && [FileChooseViewController getChooseFilesCount] < _maxSelectCount){
    cell.accessoryType = UITableViewCellAccessoryCheckmark;
    [FileChooseViewController addChooseFile:pathname maxSelectCount:_maxSelectCount];
  }else{
    cell.accessoryType =UITableViewCellAccessoryNone;
    [FileChooseViewController removeChooseFile:pathname];
  }    
  [self refreshSendButton];
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
  return TABLEVIEW_ROW_HIGHT;
}

#pragma mark - UITableViewDataSource
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
  if(emptyView == nil){
    NSArray *views = [[NSBundle mainBundle] loadNibNamed:@"EmptyView" owner:nil options:nil];
    emptyView = [views lastObject];
  }
  [self->tableView tableViewDisplayView:emptyView ifNecessaryForRowCount:[folder getFileCount]];
  return [folder getFileCount];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
  
  static NSString *CellIdentifier = @"FileCell";
  UITableViewCell *cell = [self->tableView dequeueReusableCellWithIdentifier:CellIdentifier];
  
  if (!cell){
    cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier];
  }
  
  FileInfoData* data = [folder getFileInfoOfIndex:indexPath.row];
  cell.textLabel.text = [data pathName];
  bool isDir = [data isDir];
  if(isDir){
    cell.detailTextLabel.text = [NSString stringWithFormat:@"%lu项   %@",(unsigned long) (unsigned long)[data subcount], [data strModDate]];
  }else{
    cell.detailTextLabel.text = [NSString stringWithFormat:@"%@   %@", [data size], [data strModDate]];
  }
  
  if(isDir){
    cell.imageView.image = [UIImage imageNamed:@"folder"];
    cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
  }else{
    switch ([data filetype]) {
      case FileType_TXT:
        cell.imageView.image = [UIImage imageNamed:@"txt"];
        break;
      case FileType_DOC:
        cell.imageView.image = [UIImage imageNamed:@"word"];
        break;
      case FileType_PDF:
        cell.imageView.image = [UIImage imageNamed:@"pdf"];
        break;
      case FileType_PICTURE:
        cell.imageView.image = [UIImage imageNamed:@"picture"];
        break;
      case FileType_MOVIE:
        cell.imageView.image = [UIImage imageNamed:@"movie"];
        break;
      case FileType_MUSIC:
        cell.imageView.image = [UIImage imageNamed:@"music"];
        break;
      case FileType_ZIP:
        cell.imageView.image = [UIImage imageNamed:@"zip"];
        break;
      default:
        cell.imageView.image = [UIImage imageNamed:@"other"];
        break;
    }
  }

  cell.selectionStyle = UITableViewCellSelectionStyleNone; //选中cell时无色
  if(data.isDir){
    cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
  }else{
     NSString* pathname = [folder getPathNameOfIndex:indexPath.row];
    if([FileChooseViewController choosedFile:pathname]){
      cell.accessoryType = UITableViewCellAccessoryCheckmark;
    }else{
      cell.accessoryType = UITableViewCellAccessoryNone;
    }
  }
  return cell;
}

@end

