//
//  FolderData.h
//  FileBrowser
//
//  Created by leeh on 16/9/7.
//  Copyright © 2016年 leeh. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "FileInfoData.h"

@interface FolderData : NSObject

-(NSArray*) getFolderInfos;

- (id)initWithPath:(NSString *)path
            isSearch:(bool)bSearch;

- (id)initWithPathByFilter:(NSString *)path
                filtertype:(JUFileType)type;

- (void)updateFolderInfos:(NSUInteger) sorttype;

//文件搜索
- (void)searchFolderInfos:(NSString*)searchstr
                 sortType:(NSUInteger) sorttype;

- (void)setPath:(NSString *)path;

-(FileInfoData*)getFileInfoOfIndex:(NSInteger)index;

-(NSString*)getPathNameOfIndex:(NSInteger)index;

-(NSInteger)getFileCount;

-(bool)fileExistsAtPath:(NSString *)path;

-(bool)createDirectoryAtPath:(NSString *)name
                      error:(NSError **)error;

- (bool)renameFile:(NSString *)oldname
            to:(NSString *)newname
               error:(NSError **)error;

-(bool)copyFile:(NSString *)name
            new:(NSString *)newname
          error:(NSError **)error;

//设置拷贝或者剪切的的源路径名
-(void)setOrgPathName:(NSString *)name
           operateTye:(NSInteger)operate;

//粘贴操作
-(bool)pasteFile:(NSError **)error;

//获取预定的文件操作路径名称
-(NSString*)getOrgFileOperate:(NSInteger *)operateType;

-(bool)deleteFile:(NSString *)name
            error:(NSError **)error;

- (BOOL)renameFileByIndex:(NSInteger)index
                       to:(NSString *)newname
                    error:(NSError **)error;

-(bool)deleteFileByIndex:(NSUInteger)index
                   error:(NSError **)error;
@end
