/*
 Erica Sadun, http://ericasadun.com
 iPhone Developer's Cookbook, 3.0 Edition
 BSD License, Use at your own risk
 */

#import <UIKit/UIKit.h>

// Path utilities
NSString *NSDocumentsFolder(void);
NSString *NSLibraryFolder(void);
NSString *NSTmpFolder(void);
NSString *NSBundleFolder(void);
NSString *NSDCIMFolder(void);

@interface NSFileManager (Utilities)
+ (NSString *) pathForItemNamed: (NSString *) fname inFolder: (NSString *) path;
+ (NSString *) pathForDocumentNamed: (NSString *) fname;
+ (NSString *) pathForBundleDocumentNamed: (NSString *) fname;

+ (NSArray *) pathsForItemsMatchingExtension: (NSString *) ext inFolder: (NSString *) path;
+ (NSArray *) pathsForDocumentsMatchingExtension: (NSString *) ext;
+ (NSArray *) pathsForBundleDocumentsMatchingExtension: (NSString *) ext;

+ (NSArray *) filesInFolder: (NSString *) path;

// The methods below are not implemented in upstream repository and UIImage class handles these cases.
// So commenting out.
//+ (UIImage *) imageNamed: (NSString *) aName;
//+ (UIImage *) imageFromURLString: (NSString *) urlstring;
@end

