//
//  SearchViewController.m
//  FileBrowser
//
//  Created by leeh on 16/9/9.
//  Copyright © 2016年 leeh. All rights reserved.
//
#import "UIKit/UIKit.h"
#import <QuickLook/QuickLook.h>
#import "NSFileManager-Utilities.h"
#import "FileInfoData.h"
#import "FolderData.h"
#import "YCXMenu.h"
#import "YCXMenuItem.h"
#import "SearchViewController.h"
#import "UITableView+WLEmptyPlaceHolder.h"

@interface SearchViewController () <UITableViewDataSource, UITableViewDelegate, QLPreviewControllerDataSource, UISearchBarDelegate>{
  UILongPressGestureRecognizer *longPress;
  FolderData* folder;
  NSInteger curIndex;
  NSArray* sortitems;
  UIView* emptyView;
  UIButton* sortButton;
  //bool isFistEnter;
  NSString* curSearchStr;
}
@end

static NSUInteger gSorttype = 0;

@implementation SearchViewController


- (id)init{
  self = [super initWithStyle:UITableViewStylePlain];
  if(self){
    
    self.tableView.sectionHeaderHeight = 40.0f;
    self.tableView.separatorInset = UIEdgeInsetsMake(0, 0, 0, 5);
    self.tableView.separatorStyle = UITableViewCellSeparatorStyleSingleLine;
    
    UIBarButtonItem *negativeSpacer = [[UIBarButtonItem alloc]
                                       initWithBarButtonSystemItem:UIBarButtonSystemItemFixedSpace
                                       target:nil action:nil];
    negativeSpacer.width = -5.0f;
    
    NSMutableArray* buttons = [[NSMutableArray alloc]initWithCapacity:2];
    [buttons addObject:negativeSpacer];

    UISearchBar* searchBar = [[UISearchBar alloc] initWithFrame:CGRectMake(0, 0, [UIScreen mainScreen].bounds.size.width - 50, 30)];
    
    searchBar.placeholder = @"请输入文件名或文件扩展名";
    searchBar.backgroundColor = [UIColor clearColor];
    //searchBar.layer.borderWidth = 0.5f;
    searchBar.delegate = self;
    //[searchBar setShowsCancelButton:YES animated:YES];
    [searchBar setAutocapitalizationType:UITextAutocapitalizationTypeNone];
    [searchBar sizeToFit];
    UIBarButtonItem *searchButton = [[UIBarButtonItem alloc]initWithCustomView:searchBar];
  
    //self.navigationItem.leftBarButtonItems = nil;
    self.navigationItem.titleView = nil;
  
    [buttons addObject:searchButton];
  
    //self.navigationItem.hidesBackButton = YES;
    self.navigationItem.rightBarButtonItems = buttons;
    
    UIButton *backButton = [UIButton buttonWithType:UIButtonTypeCustom];
    [backButton setFrame:CGRectMake(0, 0, 50, 30)];
    [backButton setImage:[UIImage imageNamed:@"back"] forState:UIControlStateNormal];
    [backButton addTarget:self action:@selector(searchBarBackClicked:) forControlEvents:UIControlEventTouchUpInside];
    
    UIBarButtonItem *backButtonItem = [[UIBarButtonItem alloc] initWithCustomView:backButton];
    
    UIBarButtonItem*leftnegativeSpacer = [[UIBarButtonItem alloc]
                                       initWithBarButtonSystemItem:UIBarButtonSystemItemFixedSpace
                                       target:nil action:nil];
    leftnegativeSpacer.width = -20.0f;
    
    self.navigationItem.leftBarButtonItems = @[leftnegativeSpacer, backButtonItem];
  
    //[[UIBarButtonItem appearanceWhenContainedIn: [UISearchBar class], nil] setTintColor:[UIColor blackColor]];
    //[[UIBarButtonItem appearanceWhenContainedIn: [UISearchBar class], nil] setTitle:@"取消"];
    [searchBar becomeFirstResponder];
    UITextField *searchField = nil;
    //UIButton* cancelBtton = nil;
    NSArray* subviews = nil;
    
    if([[[UIDevice currentDevice] systemVersion] floatValue] < 7.0){
      subviews = searchBar.subviews;
    }else{
      subviews = searchBar.subviews[0].subviews;
    }
    
    for(id search in subviews) {
      if([search isKindOfClass:[UITextField class]]||
         [search isKindOfClass:NSClassFromString(@"UISearchBarTextField")]) {
        searchField = (UITextField *)search;
        //if(cancelBtton != nil){
          break;
        //}
      }
      
//      if([search isKindOfClass:[UIButton class]]){
//        cancelBtton = (UIButton *)search;
//        if(searchField != nil){
//          break;
//        }
//      }
    }
    
    if(searchField){
      searchField.borderStyle = UITextBorderStyleRoundedRect;
      // 设置搜索栏输入框边框颜色
      searchField.layer.cornerRadius = 4.0f;
      searchField.layer.masksToBounds = YES;
      searchField.layer.borderColor = [[UIColor colorWithRed:118.0f/255.0f green:193.0f/255.0f blue:220.0f/255.0f alpha:1.0f]CGColor];
      searchField.layer.borderWidth = 1.0f;
    }
    
//    if(cancelBtton){    
//      // 设置搜索栏输入框边框颜色
//      cancelBtton.layer.cornerRadius = 1.0f;
//      cancelBtton.layer.masksToBounds = YES;
//      cancelBtton.layer.borderColor = [[UIColor colorWithRed:118.0f/255.0f green:193.0f/255.0f blue:220.0f/255.0f alpha:1.0f]CGColor];
//      cancelBtton.layer.borderWidth = 0.5f;
//    }
    folder = [[FolderData alloc] initWithPath:NSDocumentsFolder()
                                     isSearch:true];
    //isFistEnter = true;
    //[folder searchFolderInfos:nil sortType:gSorttype];
    curSearchStr = @"";
    return self;
  }
  return nil;
}

- (void)viewDidLoad {
  [super viewDidLoad];
}

- (void)viewWillDisappear:(BOOL)animated{
  if ([self.navigationController.viewControllers indexOfObject:self] == NSNotFound){
    //用户点击了返回按钮
    [_delegate refreshContent];
  }
  [super viewWillDisappear:animated];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

- (void)searchBarBackClicked:(UIBarButtonItem *)searchBar{
  [self.navigationController popToViewController:[self.navigationController.viewControllers objectAtIndex:self.navigationController.viewControllers.count - 2]
                                        animated:YES];
}

-(void)refreshContent{
  [folder searchFolderInfos:nil sortType:gSorttype];
  [self.tableView reloadData];
}

-(void)buttonTouchDownClick:(UIButton *)sender{
    if ([YCXMenu isShow]){
        [YCXMenu dismissMenu];
    }
    
    UIColor* orgColor = sender.backgroundColor;
    sender.backgroundColor = [UIColor colorWithRed:0.8 green:0.8 blue:0.8 alpha:0.3];
    [sender setTitleColor:[UIColor colorWithRed:0.157 green:0.686 blue:0.973 alpha:1] forState:UIControlStateNormal];
    dispatch_after (dispatch_time (DISPATCH_TIME_NOW, (int64_t )(0.2 * NSEC_PER_SEC )), dispatch_get_main_queue (), ^{
        sender.backgroundColor = orgColor;
        [sender setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    });
}

-(void)sortFile:(UIButton *)sender{
    if(sortitems == nil){
        sortitems = @[
                      [YCXMenuItem menuItem:@"名称"
                                      image:[UIImage imageNamed:@"sortletter"]
                                        tag:0
                                   userInfo:nil],
                      [YCXMenuItem menuItem:@"时间"
                                      image:[UIImage imageNamed:@"sorttime"]
                                        tag:1
                                   userInfo:nil]
                      ];
    }

    // 通过NavigationBarItem显示Menu
    [YCXMenu setTintColor:[UIColor whiteColor]];
    [YCXMenu setSelectedColor:[UIColor colorWithRed:0.8 green:0.8 blue:0.8 alpha:0.3]];
    [YCXMenu setCornerRadius:2];
    [YCXMenu setHasShadow:YES];

    [YCXMenu setArrowSize:6];
    [YCXMenu setMenuItemMarginY:8];
    [YCXMenu setSeparatorColor:[UIColor colorWithRed:0.8 green:0.8 blue:0.8 alpha:0.3]];

    //定位箭头位置
    UIButton* btn = sender;
    CGRect barFrame = [btn convertRect:btn.bounds toView:nil];
    barFrame.origin.y += 5;
    barFrame.origin.x += 10;
    barFrame.size.width = 20;
  
    [YCXMenu showMenuInView:self.view fromRect:barFrame menuItems:sortitems selected:^(NSInteger index,
                                                                                     YCXMenuItem *item) {
    NSLog(@"index=%ld %@", (long)index, item);
    if(gSorttype != [item tag]){
      gSorttype = [item tag];
      if(gSorttype == 0){
        [sortButton setTitle:@"名称排序" forState:UIControlStateNormal];
      }else{
        [sortButton setTitle:@"时间排序" forState:UIControlStateNormal];
      }
      [self refreshContent];
    };
    }];
}

- (void)renameFile:(NSUInteger)index toFile:(NSString *)newName {
  NSError *error;
  [folder renameFileByIndex:index to:newName error:&error];
   if(error != nil){
     [self showAlert:@"重命名" Message:error.localizedDescription];
     return;
   }
   [self.tableView reloadData];
}

- (void)deleteFile:(NSIndexPath *)indexPath {
  NSError *error;
  if([folder deleteFileByIndex:indexPath.row error:&error]){
    [self.tableView reloadData];
    return;
  }
  if(error != nil){
    [self showAlert:@"删除失败：" Message:error.localizedDescription];
  }
}

- (void)renameAlert:(NSIndexPath *)indexPath {
  NSString *filename = [[folder getFileInfoOfIndex:indexPath.row] pathName];
  UIAlertController *renameAlert = [UIAlertController alertControllerWithTitle:@"重命名" message:nil preferredStyle:UIAlertControllerStyleAlert];
  [renameAlert addTextFieldWithConfigurationHandler:^(UITextField *textField) {
    textField.text = filename;
  }];
  
  UIAlertAction *rename = [UIAlertAction actionWithTitle:@"重命名" style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) {
    for(UITextField *textField in renameAlert.textFields) {
      [self renameFile:indexPath.row toFile:textField.text];
    }
  }];
  
  UIAlertAction *cancel = [UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleCancel handler:nil];
  
  [renameAlert addAction:rename];
  [renameAlert addAction:cancel];
  
  [self presentViewController:renameAlert animated:YES completion:nil];
}

- (void)showAlert:(NSString *)title Message:(NSString *)message {
  UIAlertController *showAlert = [UIAlertController alertControllerWithTitle:title message:message preferredStyle:UIAlertControllerStyleAlert];
  [self presentViewController:showAlert animated:YES completion:nil];
  dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(2 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
    [self dismissViewControllerAnimated:YES completion:nil];
  });
}

//MARK: Handle LongPressGesture
-(void)handleLongPress:(UILongPressGestureRecognizer *)gestureRecognizer {
  CGPoint p = [gestureRecognizer locationInView:self.tableView];
  NSIndexPath *indexPath = [self.tableView indexPathForRowAtPoint:p];
  if (indexPath != nil) {
    if (gestureRecognizer.state == UIGestureRecognizerStateBegan) {
      [self renameAlert:indexPath];
    }
  }
}


#pragma mark UISearchBarDelegate
- (BOOL)searchBarShouldBeginEditing:(UISearchBar *)searchBar{
  NSLog(@"searchBarShouldBeginEditing");
  return true;
}

- (void)searchBarTextDidBeginEditing:(UISearchBar *)searchBar{
  NSLog(@"searchBarTextDidBeginEditing");
}

- (BOOL)searchBarShouldEndEditing:(UISearchBar *)searchBar{
  NSLog(@"searchBarShouldEndEditing");
  return true;
}

- (void)searchBarTextDidEndEditing:(UISearchBar *)searchBar{
  NSLog(@"searchBarTextDidEndEditing");
}

- (void)searchBar:(UISearchBar *)searchBar textDidChange:(NSString *)searchText{
   NSLog(@"textDidChange");
  curSearchStr = searchText;
  [folder searchFolderInfos:searchText sortType:gSorttype];
  [self.tableView reloadData];
}

- (void)searchBarSearchButtonClicked:(UISearchBar *)searchBar{
  NSLog(@"searchBarSearchButtonClicked");
//  [folder searchFolderInfos:searchBar.text sortType:gSorttype];
//  [self.tableView reloadData];
  [searchBar resignFirstResponder];
}

- (void)searchBarResultsListButtonClicked:(UISearchBar *)searchBar{
  NSLog(@"searchBarTextDidEndEditing");
}
- (void)searchBar:(UISearchBar *)searchBar selectedScopeButtonIndexDidChange:(NSInteger)selectedScope{
  NSLog(@"selectedScopeButtonIndexDidChange");
}

#pragma mark - Table view data source
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
  // Return the number of sections.
  return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
  // Return the number of rows in the section.
  if(curSearchStr == nil || curSearchStr.length == 0){
    [tableView tableViewDisplayWitMsg:@"点击键盘上的“搜索”开始" ifNecessaryForRowCount:[folder getFileCount]];
    return [folder getFileCount];
  }
  
  if(emptyView == nil){
    NSArray *views = [[NSBundle mainBundle] loadNibNamed:@"EmptyView" owner:nil options:nil];
    emptyView = [views lastObject];
  }
  [tableView tableViewDisplayView:emptyView ifNecessaryForRowCount:[folder getFileCount]];
  return [folder getFileCount];
}

//-(void) preViewBtnClick:(id) sender
//{
//  UIButton *button = (UIButton *)sender;
//  NSInteger index = button.tag;
//  
//  QLPreviewController *previewer = [[QLPreviewController alloc] init];
//  // Set data source
//  [previewer setDataSource:self];
//  curIndex = index;
//  [[self navigationController] pushViewController:previewer animated:YES];
//}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
  static NSString *CellIdentifier = @"FileCell";
  UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
  
  if (!cell){
    cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier];
  }
  
  FileInfoData* data = [folder getFileInfoOfIndex:indexPath.row];
  cell.textLabel.text = [[data pathName] lastPathComponent];
  cell.detailTextLabel.text = [NSString stringWithFormat:@"%@   %@", [data size], [data strModDate]];

  switch ([data filetype]) {
    case FileType_TXT:
      cell.imageView.image = [UIImage imageNamed:@"txt"];
      break;
    case FileType_DOC:
      cell.imageView.image = [UIImage imageNamed:@"word"];
      break;
    case FileType_PDF:
      cell.imageView.image = [UIImage imageNamed:@"pdf"];
      break;
    case FileType_PICTURE:
      cell.imageView.image = [UIImage imageNamed:@"picture"];
      break;
    case FileType_MOVIE:
      cell.imageView.image = [UIImage imageNamed:@"movie"];
      break;
    case FileType_MUSIC:
      cell.imageView.image = [UIImage imageNamed:@"music"];
      break;
    case FileType_ZIP:
      cell.imageView.image = [UIImage imageNamed:@"zip"];
      break;
    default:
      cell.imageView.image = [UIImage imageNamed:@"other"];
      break;
  }
  
//  UIImage* img=[UIImage imageNamed:@"preview"];
//  UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
//  btn.frame =CGRectMake(0, 0, 36, 36);
//  [btn setBackgroundImage:img forState:UIControlStateNormal];
//  btn.tag = indexPath.row;
//  [btn addTarget: self action: @selector(preViewBtnClick:) forControlEvents: UIControlEventTouchUpInside];
//  cell.accessoryView = btn;
  
  
  longPress = [[UILongPressGestureRecognizer alloc] initWithTarget:self action:@selector(handleLongPress:)];
  longPress.minimumPressDuration = 1.0; //seconds
  [cell addGestureRecognizer:longPress];
  return cell;
}

-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
  return TABLEVIEW_ROW_HIGHT;
}


//MARK: UITableViewDelegate
- (void)tableView:(UITableView*)tableView didSelectRowAtIndexPath:(NSIndexPath*)indexPath
{
  //FileInfoData* data = [folder getFileInfoOfIndex:indexPath.row];
  //UIButton *button = (UIButton *)sender;
  //NSInteger index = button.tag;
  
  QLPreviewController *previewer = [[QLPreviewController alloc] init];
  // Set data source
  [previewer setDataSource:self];
  curIndex = indexPath.row;
  [[self navigationController] pushViewController:previewer animated:YES];
}

- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
  if (editingStyle == UITableViewCellEditingStyleDelete) {
    [self deleteFile:indexPath];
  }
}

-(UIView *)InitSectionToolBar{
    int startx = 10;
    UIView *headerView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, self.tableView.frame.size.width, 40)];
  
    sortButton = [UIButton buttonWithType:UIButtonTypeCustom];
    sortButton.frame = CGRectMake(startx, 5, 100, 30);
    UIImage *sortImg = [UIImage imageNamed:@"sort"];
    [sortButton setImage:sortImg forState:UIControlStateNormal];
    [sortButton setImage:sortImg forState:UIControlStateSelected];
    [sortButton setImage:sortImg forState:UIControlStateHighlighted];
    [sortButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    [sortButton setTitleColor:[UIColor colorWithRed:0.157 green:0.686 blue:0.973 alpha:1] forState:UIControlStateHighlighted];

    if(gSorttype == 0){
        [sortButton setTitle:@"名称排序" forState:UIControlStateNormal];
    }else{
        [sortButton setTitle:@"时间排序" forState:UIControlStateNormal];
    }

    sortButton.titleLabel.font = [UIFont systemFontOfSize:16];//title字体大小
    sortButton.backgroundColor = [UIColor clearColor];//colorWithRed:0.157 green:0.686 blue:0.973 alpha:1];
    sortButton.layer.cornerRadius = 4.0;

    sortButton.contentHorizontalAlignment = UIControlContentHorizontalAlignmentLeft;
    [sortButton setTitleEdgeInsets:UIEdgeInsetsMake(0, -10, 0, 0)];
    [sortButton setImageEdgeInsets:UIEdgeInsetsMake(1, 75, -1, -75)];
    [sortButton layoutIfNeeded];

    [sortButton addTarget:self action:@selector(sortFile:) forControlEvents:UIControlEventTouchUpInside];
    //点击事件
    [sortButton addTarget:self action:@selector(buttonTouchDownClick:) forControlEvents:UIControlEventTouchDown];

    [headerView addSubview:sortButton];
    startx += 120;
  
    [headerView setBackgroundColor:[UIColor colorWithRed:238.0/255.0 green:238.0/255.0 blue:238.0/255.0 alpha:1]];
    return headerView;
}

//方法如下：
- (UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section {
  //  UIView *headerView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, tableView.frame.size.width, 30)];
  //  UILabel *label = [[UILabel alloc] initWithFrame:CGRectMake(5, 5, tableView.frame.size.width, 20)];
  //  label.font = [UIFont systemFontOfSize:14.0f];  //UILabel的字体大小
  //  label.numberOfLines = 1;  //必须定义这个属性，否则UILabel不会换行
  //  label.textColor = [UIColor whiteColor];
  //  label.textAlignment = NSTextAlignmentLeft;  //文本对齐方式
  //  [label setBackgroundColor:[UIColor clearColor]];
  //
  //  [headerView setBackgroundColor:[UIColor lightGrayColor]];
  //  [headerView addSubview:label];
  //
  //  NSRange range;
  //  range = [self.path rangeOfString:gFirstpath];
  //  if(range.location != NSNotFound) {
  //    label.text = [NSString stringWithFormat:@"[%@]", [self.path substringFromIndex:range.location]];
  //  }
  return [self InitSectionToolBar];
}

-(UITableViewCellEditingStyle)tableView:(UITableView*)tableView editingStyleForRowAtIndexPath:(NSIndexPath*)indexPath {
  return UITableViewCellEditingStyleDelete;
}

#pragma mark - QuickLook

- (BOOL)previewController:(QLPreviewController *)controller shouldOpenURL:(NSURL *)url forPreviewItem:(id <QLPreviewItem>)item {
  return YES;
}

- (NSInteger) numberOfPreviewItemsInPreviewController: (QLPreviewController *) controller {
  return 1;
}

- (id <QLPreviewItem>) previewController: (QLPreviewController *) controller
                      previewItemAtIndex: (NSInteger) index {
  NSString *newPath = [folder getPathNameOfIndex:curIndex];
  return [NSURL fileURLWithPath:newPath];
}

@end
