//
//  ViewController.m
//  FileBrowser
//
//  Created by lihong on 07.09.16.
//  Copyright © 2016 lihong. All rights reserved.
//

#import "UIKit/UIKit.h"
#import "ViewController.h"
#import "FileInfoData.h"
#import "FolderData.h"
#import "YCXMenu.h"
#import "YCXMenuItem.h"
#import "FileChooseViewController.h"
#import "NSFileManager-Utilities.h"
#import "UITableView+WLEmptyPlaceHolder.h"
#import "SearchViewController.h"
#import "FilterViewController.h"

@interface ViewController () <UIAlertViewDelegate, UIGestureRecognizerDelegate> {
  UILongPressGestureRecognizer *longPress;
  FolderData* folder;
  NSInteger curIndex;
  NSArray* sortitems;
  UIButton *btnSearch;
  UIView* emptyView;
  UIButton* sortButton;
  UIView *baseView;
  bool bSelectStatus;
  
  NSMutableArray *deleteArr;//删除数据的数组
}

@property (weak, nonatomic) IBOutlet UITableView *tableView;
@property (nonatomic , strong) NSMutableArray *items;

@end

static NSString *gFirstpath = nil;
//static JUFileType gFilterFiletype = 0;
static int gSorttype = 0;

@implementation ViewController

@synthesize items = _items;

-(void)refreshContent{
  [folder updateFolderInfos:gSorttype];
  [self.tableView reloadData];
}

- (void)BackClicked:(UIBarButtonItem *)btn{
    if(_pickerDelegate != nil){
        [_pickerDelegate cancelSelect];
    }
    //[self.navigationController.viewControllers[0] dismissViewControllerAnimated:YES completion:nil];
}

-(void)buttonTouchDownClick:(UIButton *)sender{
    if ([YCXMenu isShow]){
        [YCXMenu dismissMenu];
    }
    
    UIColor* orgColor = sender.backgroundColor;
    sender.backgroundColor = [UIColor colorWithRed:0.8 green:0.8 blue:0.8 alpha:0.3];
    [sender setTitleColor:[UIColor colorWithRed:0.157 green:0.686 blue:0.973 alpha:1] forState:UIControlStateNormal];
    dispatch_after (dispatch_time (DISPATCH_TIME_NOW, (int64_t )(0.2 * NSEC_PER_SEC )), dispatch_get_main_queue (), ^{
        sender.backgroundColor = orgColor;
        [sender setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    });
}

-(void)CreateToolBar{
//  UIToolbar* tools = [[UIToolbar alloc]initWithFrame:CGRectMake(0, 0, 170, 40)];
//  //解决出现的那条线
//  tools.clipsToBounds = YES;
//  //解决tools背景颜色的问题
//  [tools setBackgroundImage:[UIImage new] forToolbarPosition:UIBarPositionAny barMetrics:UIBarMetricsDefault];
//  [tools setShadowImage:[UIImage new] forToolbarPosition:UIToolbarPositionAny];
  
  UIBarButtonItem *negativeSpacer = [[UIBarButtonItem alloc]
                                     initWithBarButtonSystemItem:UIBarButtonSystemItemFixedSpace
                                     target:nil action:nil];
  /**
   *  width为负数时，相当于btn向右移动width数值个像素，由于按钮本身和边界间距为5pix，所以width设为-5时，间距正好调整
   *  为0；width为正数时，正好相反，相当于往左移动width数值个像素
   */
  negativeSpacer.width = -20.0f;

  NSMutableArray* buttons = [[NSMutableArray alloc]initWithCapacity:10];
  [buttons addObject:negativeSpacer];
  
  UIButton* backButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
  backButton.frame = CGRectMake(0, 0, 50, 30);
  backButton.backgroundColor = [UIColor clearColor];//colorWithRed:0 green:172.0/255.0 blue:59.0/255.0 alpha:1];
  backButton.layer.cornerRadius = 5.0;
  backButton.contentHorizontalAlignment = UIControlContentHorizontalAlignmentLeft;
    
  CGColorSpaceRef colorSpace = CGColorSpaceCreateDeviceRGB();
  CGColorRef colorref = CGColorCreate(colorSpace,(CGFloat[]){ 0.157, 0.686, 0.973, 1 });
  [backButton.layer setBorderColor:colorref];//边框颜色
  //backButton.layer.borderWidth = 0.3f;
  
  if(_retLabelTitle && _retLabelTitle.length > 0){
    [backButton setTitle:_retLabelTitle forState:UIControlStateNormal];
  }else{
    [backButton setTitle:@"退出" forState:UIControlStateNormal];
  }
  
  [backButton setTitleColor:[UIColor colorWithRed:0.157 green:0.686 blue:0.973 alpha:1] forState:UIControlStateNormal];
  [backButton addTarget:self action:@selector(BackClicked:) forControlEvents:UIControlEventTouchUpInside];
    
  UIBarButtonItem *backBtnItem = [[UIBarButtonItem alloc] initWithCustomView:backButton];
  [buttons addObject:backBtnItem];

//  UIButton *btnAttach = [UIButton buttonWithType:UIButtonTypeCustom];
//  [btnAttach setFrame:CGRectMake(0, 0, 30, 30)];
//  [btnAttach setImage:[UIImage imageNamed:@"attach"] forState:UIControlStateNormal];
//  btnAttach.layer.cornerRadius = 4.0;
//  btnAttach.layer.borderWidth = 0.3f;
//  [btnAttach addTarget:self action:@selector(attach:) forControlEvents:UIControlEventTouchUpInside];
//  UIBarButtonItem* btnItemAttach = [[UIBarButtonItem alloc] initWithCustomView:btnAttach];
//  
//  //
//  //  UIBarButtonItem* btnDelete =[[UIBarButtonItem alloc]initWithImage:[UIImage imageNamed:@"delete"] style: UIBarButtonItemStylePlain target:self action:@selector(DeleteFile:)];
//  
//  [buttons addObject:btnItemAttach];
    
    btnSearch = [UIButton buttonWithType:UIButtonTypeCustom];
    [btnSearch setFrame:CGRectMake(0, 0, 30, 30)];
    [btnSearch setImage:[UIImage imageNamed:@"search"] forState:UIControlStateNormal];
    btnSearch.layer.cornerRadius = 4.0;
    //btnSearch.layer.borderWidth = 0.3f;
    [btnSearch addTarget:self action:@selector(searchFile:) forControlEvents:UIControlEventTouchUpInside];
    [btnSearch addTarget:self action:@selector(buttonTouchDownClick:) forControlEvents:UIControlEventTouchDown];

    UIBarButtonItem *btnItemSearch = [[UIBarButtonItem alloc] initWithCustomView:btnSearch];
    [buttons addObject:btnItemSearch];
  
    UIButton *btnFilter = [UIButton buttonWithType:UIButtonTypeCustom];
    [btnFilter setFrame:CGRectMake(0, 0, 30, 30)];
    [btnFilter setImage:[UIImage imageNamed:@"filter"] forState:UIControlStateNormal];
    btnFilter.layer.cornerRadius = 4.0;
    //btnFilter.layer.borderWidth = 0.3f;
    [btnFilter addTarget:self action:@selector(showFilter:) forControlEvents:UIControlEventTouchUpInside];
    [btnFilter addTarget:self action:@selector(buttonTouchDownClick:) forControlEvents:UIControlEventTouchDown];

    UIBarButtonItem *btnItemfilter = [[UIBarButtonItem alloc] initWithCustomView:btnFilter];
    [buttons addObject:btnItemfilter];
  
    if (self.navigationController.viewControllers.count > 1){
        UIButton *btnHome = [UIButton buttonWithType:UIButtonTypeCustom];
        [btnHome setFrame:CGRectMake(0, 0, 30, 30)];
        [btnHome setImage:[UIImage imageNamed:@"home"] forState:UIControlStateNormal];
        btnHome.layer.cornerRadius = 4.0;
        //btnHome.layer.borderWidth = 0.3f;

        [btnHome addTarget:self action:@selector(goHome:) forControlEvents:UIControlEventTouchUpInside];
        UIBarButtonItem *btnItemHome = [[UIBarButtonItem alloc] initWithCustomView:btnHome];

        //    UIBarButtonItem* btnHome =[[UIBarButtonItem alloc]initWithImage:[UIImage imageNamed:@"home"] style: UIBarButtonItemStylePlain target:self action:@selector(goHome:)];
        [buttons addObject:btnItemHome];
    }
//  }else{
//      UIButton *backButton = [UIButton buttonWithType:UIButtonTypeCustom];
//      [backButton setFrame:CGRectMake(0, 0, 50, 30)];
//      [backButton setImage:[UIImage imageNamed:@"back"] forState:UIControlStateNormal];
//      [backButton addTarget:self action:@selector(BackClicked:) forControlEvents:UIControlEventTouchUpInside];
//      
//      UIBarButtonItem *backButtonItem = [[UIBarButtonItem alloc] initWithCustomView:backButton];
//      [buttons addObject:backButtonItem];
//      
//      UIBarButtonItem*leftnegativeSpacer = [[UIBarButtonItem alloc]
//                                            initWithBarButtonSystemItem:UIBarButtonSystemItemFixedSpace
//                                            target:nil action:nil];
//      leftnegativeSpacer.width = -20.0f;
//      [buttons addObject:leftnegativeSpacer];
//      
//      //self.navigationItem.leftBarButtonItems = @[leftnegativeSpacer, backButtonItem];
//      //    UIBarButtonItem* btnHome =[[UIBarButtonItem alloc]initWithImage:[UIImage imageNamed:@"home"] style: UIBarButtonItemStylePlain target:self action:@selector(goHome:)];
//      
//  }
  
  //[tools setItems:buttons animated:YES];
  //UIBarButtonItem* btns = [[UIBarButtonItem alloc]initWithCustomView:tools];

    self.navigationItem.rightBarButtonItems = buttons;//[NSArray arrayWithObjects:buttons, nil];;
    self.navigationItem.title = [self.path lastPathComponent];
}

    //MARK: Life cycle
- (void)viewDidLoad {
    [super viewDidLoad];
  
    self.tableView.sectionHeaderHeight = 40.0f;
    self.tableView.separatorInset = UIEdgeInsetsMake(0, 0, 0, 5);
    self.tableView.separatorStyle = UITableViewCellSeparatorStyleSingleLine;
    CGRect frame = self.tableView.frame;
    frame.size.height -= 40;
    self.tableView.frame = frame;

    [self CreateToolBar];
  
    if(self.navigationController.viewControllers.count == 1) {
      //NSString* testpath = NSDocumentsFolder();
      self.path = NSDocumentsFolder();//NSHomeDirectory();[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
      gFirstpath = [self.path lastPathComponent];
//      UIBarButtonItem *backItem = [[UIBarButtonItem alloc] initWithTitle:@"" style:UIBarButtonItemStylePlain target:nil action:nil];
//      [self.navigationItem setBackBarButtonItem:backItem];
    }
  
    self.tableView.editing = NO;//默认tableview的editing 是不开启的
    bSelectStatus = false;
  
    deleteArr = [NSMutableArray array];
  
    folder = [[FolderData alloc] initWithPath:self.path
              isSearch:false];
    [folder updateFolderInfos:0];
  
  
  
    // 用 searchbar 初始化 SearchDisplayController
    // 并把 searchDisplayController 和当前 controller 关联起来
//    searchDisplayController = [[UISearchDisplayController alloc] initWithSearchBar:btnSearch contentsController:self];
  
    // searchResultsDataSource 就是 UITableViewDataSource
    //searchDisplayController.searchResultsDataSource = self;
    // searchResultsDelegate 就是 UITableViewDelegate
    //searchDisplayController.searchResultsDelegate = self;
}

- (void)viewWillDisappear:(BOOL)animated{
  if ([self.navigationController.viewControllers indexOfObject:self] == NSNotFound){
    //用户点击了返回按钮
    [_delegate refreshContent];
  }
  [super viewWillDisappear:animated];
}

#pragma mark - Operate Function

- (void)goHome:(UIBarButtonItem *)sender{
  if([YCXMenu isShow]){
    [YCXMenu dismissMenu];
  }
  
  [self.navigationController popToRootViewControllerAnimated:YES];
}

- (void)attach:(UIBarButtonItem *)sender{
  if([YCXMenu isShow]){
    [YCXMenu dismissMenu];
  }
  
  NSString* path = NSDocumentsFolder();//[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
  FileChooseViewController* vc = [[FileChooseViewController alloc] initWithPath:path
                                                                      parentDir:@""];
  [self.navigationController pushViewController:vc animated:YES];
}

-(void)searchFile:(UIBarButtonItem *)sender{
  if([YCXMenu isShow]){
    [YCXMenu dismissMenu];
  }
  
  SearchViewController* vc = [[SearchViewController alloc] init];
  vc.delegate = self;
  [self.navigationController pushViewController:vc animated:YES];
}

#pragma mark - setter/getter
- (NSMutableArray *)items {
  if (!_items) {
    //set item
    _items = [@[
                [YCXMenuItem menuItem:@"全部"
                                image:[UIImage imageNamed:@"other"]
                                  tag:0
                             userInfo:nil],
                [YCXMenuItem menuItem:@"文档"
                                image:[UIImage imageNamed:@"word"]
                                  tag:FileType_DOC
                             userInfo:nil],
                [YCXMenuItem menuItem:@"图片"
                                image:[UIImage imageNamed:@"picture"]
                                  tag:FileType_PICTURE
                             userInfo:nil],
                [YCXMenuItem menuItem:@"压缩包"
                                image:[UIImage imageNamed:@"zip"]
                                  tag:FileType_ZIP
                             userInfo:nil],
                [YCXMenuItem menuItem:@"音乐"
                                image:[UIImage imageNamed:@"music"]
                                  tag:FileType_MUSIC
                             userInfo:nil],
                [YCXMenuItem menuItem:@"电影"
                                image:[UIImage imageNamed:@"movie"]
                                  tag:FileType_MOVIE
                             userInfo:nil]
                ] mutableCopy];
  }
  return _items;
}

- (void)setItems:(NSMutableArray *)items {
  _items = items;
}

- (void)showFilter:(UIButton *)sender{
  if ([YCXMenu isShow]){
    [YCXMenu dismissMenu];
  }
  
  // 通过NavigationBarItem显示Menu
  [YCXMenu setTintColor:[UIColor whiteColor]];
  [YCXMenu setSelectedColor:[UIColor colorWithRed:0.8 green:0.8 blue:0.8 alpha:0.3]];
  [YCXMenu setCornerRadius:2];
  [YCXMenu setHasShadow:YES];
  
  [YCXMenu setArrowSize:6];
  [YCXMenu setMenuItemMarginY:8];
  [YCXMenu setSeparatorColor:[UIColor colorWithRed:0.8 green:0.8 blue:0.8 alpha:0.3]];
  
  //定位箭头位置
  UIButton* btn = sender;
  CGRect barFrame = [btn convertRect:btn.bounds toView:nil];
  barFrame.origin.y += 10;
  barFrame.size.width = 20;
    
  [YCXMenu showMenuInView:self.view fromRect:barFrame menuItems:self.items selected:^(NSInteger index, YCXMenuItem *item) {
    NSLog(@"index=%ld %@", (long)index, item);
    
    if([YCXMenu isShow]){
      [YCXMenu dismissMenu];
    }
    
    FilterViewController* vc = [[FilterViewController alloc] initWithFileType:(JUFileType)[item tag]];
     vc.delegate = self;
    [self.navigationController pushViewController:vc animated:YES];
  }];
}

-(void)sortFile:(UIButton *)sender{

    if(sortitems == nil){
        sortitems = @[
                      [YCXMenuItem menuItem:@"名称"
                                      image:[UIImage imageNamed:@"sortletter"]
                                        tag:0
                                   userInfo:nil],
                      [YCXMenuItem menuItem:@"时间"
                                      image:[UIImage imageNamed:@"sorttime"]
                                        tag:1
                                   userInfo:nil]
                      ];
    }

    // 通过NavigationBarItem显示Menu
    [YCXMenu setTintColor:[UIColor whiteColor]];
    [YCXMenu setSelectedColor:[UIColor colorWithRed:0.8 green:0.8 blue:0.8 alpha:0.3]];
    [YCXMenu setCornerRadius:2];
    [YCXMenu setHasShadow:YES];

    [YCXMenu setArrowSize:6];
    [YCXMenu setMenuItemMarginY:8];
    [YCXMenu setSeparatorColor:[UIColor colorWithRed:0.8 green:0.8 blue:0.8 alpha:0.3]];

    //定位箭头位置
    UIButton* btn = sender;
    CGRect barFrame = [btn convertRect:btn.bounds toView:nil];
    barFrame.origin.y += 5;
    barFrame.origin.x += 10;
    barFrame.size.width = 20;
  
//  int i = 0;
//  NSArray* titles = @[@"名称", @"时间"];
//  for(YCXMenuItem *item in sortitems){
//    if(item.tag == gSorttype){
//      NSString* newtitle = [NSString stringWithFormat:@"%@  √", titles[i]];
//      item.title = newtitle;
//    }else{
//      item.title = titles[i];
//    }
//    i++;
//  }
  
  [YCXMenu showMenuInView:self.view fromRect:barFrame menuItems:sortitems selected:^(NSInteger index, YCXMenuItem *item) {
    NSLog(@"index=%ld %@", (long)index, item);
    gSorttype = (JUFileType)[item tag];
    if(gSorttype == 0){
      [sortButton setTitle:@"名称排序" forState:UIControlStateNormal];
    }else{
      [sortButton setTitle:@"时间排序" forState:UIControlStateNormal];
    }
    //[sortButton setTitle:@"" forState:<#(UIControlState)#>
    [self refreshContent];
  }];
}

- (void)createFolder:(NSString *)name{
  NSError *error;
  if(![folder fileExistsAtPath:name]) {
    [folder createDirectoryAtPath:name error:&error];
    if(error){
      [self showAlert:@"创建失败，原因：" Message:error.localizedDescription];
      return;
    }
  }else{
    [self showAlert:@"创建" Message:[NSString stringWithFormat:@"目录：'%@' 已存在！", name]];
    return;
  }
  
  [self refreshContent];
  if(self.delegate != nil){
    [self.delegate refreshContent];
  }
}

- (void)renameFile:(NSString *)oldName toFile:(NSString *)newName {
    if ([oldName isEqualToString:newName]) {
        return;
    }
  
    NSError *error;
    if (![folder fileExistsAtPath:newName]) {
        [folder renameFile:oldName to:newName error:&error];
      if(error){
        [self showAlert:@"重命名" Message:error.localizedDescription];
        return;
      }
    }else{
      [self showAlert:@"重命名" Message:[NSString stringWithFormat:@"该名称： %@ 已存在！", newName]];
      return;
    }
    [self refreshContent];
}

- (void)copyFile:(NSIndexPath *)indexPath {
    NSString *fileName = [[folder getFileInfoOfIndex:indexPath.row] pathName];
    NSString *newName = [self nameGenerator:fileName];
    NSError *error;
    if(![folder fileExistsAtPath:newName]) {
      [folder copyFile:fileName new:newName error:&error];
      if(error){
        [self showAlert:@"复制失败：" Message:error.localizedDescription];
        return;
      }
    }else{
      [self copyFile:indexPath];
    }
    [self refreshContent];
}

- (NSString *)nameGenerator:(NSString *)oldName {
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    [formatter setDateFormat:@"(HH:mm:ss)"];
    NSString *dateString = [formatter stringFromDate:[NSDate date]];
    NSString *newName = [oldName stringByAppendingString:dateString];
    return newName;
}

- (void)catFile:(NSIndexPath *)indexPath {
    //TODO:
    NSString *fileName = [[folder getFileInfoOfIndex:indexPath.row] pathName];
    [folder setOrgPathName:fileName operateTye:1];
}

- (void)deleteFile:(NSIndexPath *)indexPath {
  
    NSString *name = [[folder getFileInfoOfIndex:indexPath.row] pathName];
    NSError *error;
    if([folder deleteFile:name error:&error]){
      [self refreshContent];
      return;
    }
    [self showAlert:@"删除失败：" Message:error.localizedDescription];
}

-(void)paste:(id)sender{
  NSError* error;
  [folder pasteFile:&error];
  if(error != nil){
    [self showAlert:@"粘贴失败：" Message:error.localizedDescription];  }
  [self refreshContent];
}

-(void)select:(id)sender{
  if ([YCXMenu isShow]){
    [YCXMenu dismissMenu];
  }
  
  bSelectStatus = true;
  //支持同时选中多行
  self.tableView.allowsMultipleSelectionDuringEditing = YES;
  self.tableView.editing = true;
  [self refreshContent];
}

-(void)cancelSelect:(id)sender{
  if ([YCXMenu isShow]){
    [YCXMenu dismissMenu];
  }
  
  bSelectStatus = false;
  //支持同时选中多行
  self.tableView.allowsMultipleSelectionDuringEditing = NO;
  self.tableView.editing = false;
  if(sender){
    [self refreshContent];
  }
}

-(void)selectAllCell:(UIButton*)sender{
  if ([YCXMenu isShow]){
    [YCXMenu dismissMenu];
  }
  
  if([sender.currentTitle isEqualToString: @"全选"])
  {
    for(int i = 0; i < [folder getFileCount]; i ++) {
      NSIndexPath *indexPath = [NSIndexPath indexPathForItem:i inSection:0];
      [self.tableView selectRowAtIndexPath:indexPath animated:YES scrollPosition:UITableViewScrollPositionTop];
    }
    [deleteArr addObjectsFromArray:[folder getFolderInfos]];
    [sender setTitle:@"全不选" forState:UIControlStateNormal];
  }else{
    for(int i = 0; i < [folder getFileCount]; i ++) {
      NSIndexPath *indexPath = [NSIndexPath indexPathForItem:i inSection:0];
      [self.tableView deselectRowAtIndexPath:indexPath animated:YES];
    }
    [deleteArr removeAllObjects];
    [sender setTitle:@"全选" forState:UIControlStateNormal];
  }
}
//- (void)delete:(id)sender {
//  NSIndexPath* indexPath = [self.tableView indexPathForSelectedRow];
//  if(indexPath != nil){
//    [self deleteFile:indexPath];
//  }
//}

//MARK: Alerts
- (void)createAlert {
    UIAlertController *createAlert = [UIAlertController alertControllerWithTitle:@"创建文件夹" message:@"" preferredStyle:UIAlertControllerStyleAlert];
    [createAlert addTextFieldWithConfigurationHandler:^(UITextField *textField) {
        textField.placeholder = @"文件夹名";
    }];
    
    UIAlertAction *directory = [UIAlertAction actionWithTitle:@"创建" style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) {
        if (createAlert.textFields[0].text.length > 0) {
            [self createFolder:createAlert.textFields[0].text];
        }
    }];
  
    UIAlertAction *cancel = [UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleCancel handler:^(UIAlertAction *action) {
    }];
    
    [createAlert addAction:directory];
    [createAlert addAction:cancel];
    [self presentViewController:createAlert animated:YES completion:nil];
}

- (void)actionsAlert:(NSIndexPath *)indexPath {
    UIAlertController *actionsAlert = [UIAlertController alertControllerWithTitle:@"操作" message:nil preferredStyle:UIAlertControllerStyleAlert];
    
    UIAlertAction *rename = [UIAlertAction actionWithTitle:@"重命名" style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) {
        [self renameAlert:indexPath];
    }];
    
    UIAlertAction *copy = [UIAlertAction actionWithTitle:@"复制" style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) {
        [self copyFile:indexPath];
    }];
    
    UIAlertAction *move = [UIAlertAction actionWithTitle:@"剪切" style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) {
        [self catFile:indexPath];
    }];
  
    UIAlertAction *delete = [UIAlertAction actionWithTitle:@"删除" style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) {
        [self deleteFile:indexPath];
    }];
    
    UIAlertAction *cancel = [UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleCancel handler:nil];
    
    [actionsAlert addAction:rename];
    [actionsAlert addAction:copy];
    [actionsAlert addAction:move];
    [actionsAlert addAction:delete];
    [actionsAlert addAction:cancel];

    [self presentViewController:actionsAlert animated:YES completion:nil];
}

- (void)renameAlert:(NSIndexPath *)indexPath {
    NSString *filename = [[folder getFileInfoOfIndex:indexPath.row] pathName];
    UIAlertController *renameAlert = [UIAlertController alertControllerWithTitle:@"重命名" message:nil preferredStyle:UIAlertControllerStyleAlert];
    [renameAlert addTextFieldWithConfigurationHandler:^(UITextField *textField) {
        textField.text = filename;
    }];
    
    UIAlertAction *rename = [UIAlertAction actionWithTitle:@"重命名" style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) {
        for(UITextField *textField in renameAlert.textFields) {
            [self renameFile:filename toFile:textField.text];
        }
    }];
    
    UIAlertAction *cancel = [UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleCancel handler:nil];
    
    [renameAlert addAction:rename];
    [renameAlert addAction:cancel];
    
    [self presentViewController:renameAlert animated:YES completion:nil];
}

- (void)showAlert:(NSString *)title Message:(NSString *)message {
    UIAlertController *showAlert = [UIAlertController alertControllerWithTitle:title message:message preferredStyle:UIAlertControllerStyleAlert];
    [self presentViewController:showAlert animated:YES completion:nil];
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(2 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [self dismissViewControllerAnimated:YES completion:nil];
    });
}

    //MARK: Handle LongPressGesture
-(void)handleLongPress:(UILongPressGestureRecognizer *)gestureRecognizer {
    CGPoint p = [gestureRecognizer locationInView:self.tableView];
    NSIndexPath *indexPath = [self.tableView indexPathForRowAtPoint:p];
    if (indexPath != nil) {
        if (gestureRecognizer.state == UIGestureRecognizerStateBegan) {
            [self actionsAlert:indexPath];
        }
    }
}

    //MARK: Actions

- (void)addFolder:(UIBarButtonItem *)sender {
    if ([YCXMenu isShow]){
      [YCXMenu dismissMenu];
    }
  
    [self createAlert];
}

-(void)pickupFiles:(UIBarButtonItem *)sender{
    NSString* tmppath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
    FileChooseViewController *bowser = [[FileChooseViewController alloc] initWithPath:tmppath
                                        parentDir:@""];
    [self.navigationController pushViewController:bowser animated:YES];
}

//删除按钮点击事件
- (void)deleteClick:(UIButton *) button {
  if (self.tableView.editing) {
    //删除
    for(int i = 0; i < [deleteArr count]; i++){
      NSError *error = nil;
      FileInfoData* data = deleteArr[i];
      [folder deleteFile:[data pathName] error:&error];
      if(error != nil){
        break;
      }
    }
    
    [deleteArr removeAllObjects];
    [self refreshContent];
    //[self.tableView reloadData];
  }
}


#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
  // Return the number of sections.
  return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
  // Return the number of rows in the section.
  //tableViewDisplayView:(UIView *) displayView ifNecessaryForRowCount:(NSUInteger) rowCount
  
  if(emptyView == nil){
    NSArray *views = [[NSBundle mainBundle] loadNibNamed:@"EmptyView" owner:nil options:nil];
    emptyView = [views lastObject];
   }
  [tableView tableViewDisplayView:emptyView ifNecessaryForRowCount:[folder getFileCount]];
//  [tableView tableViewDisplayWitMsg:@"没有文件存在" ifNecessaryForRowCount:[folder getFileCount]];
  return [folder getFileCount];
}

//-(void) preViewBtnClick:(id) sender
//{
//  UIButton *button = (UIButton *)sender;
//  NSInteger index = button.tag;
//  
//  QLPreviewController *previewer = [[QLPreviewController alloc] init];
//  // Set data source
//  [previewer setDataSource:self];
//  curIndex = index;
//  [[self navigationController] pushViewController:previewer animated:YES];
//}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
  static NSString *CellIdentifier = @"FileCell";
  UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
  
  if (!cell){
    cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier];
  }
  
  FileInfoData* data = [folder getFileInfoOfIndex:indexPath.row];
  cell.textLabel.text = [data pathName];
  bool isDir = [data isDir];
  if(isDir){
    cell.detailTextLabel.text = [NSString stringWithFormat:@"%lu项   %@",(unsigned long) (unsigned long)[data subcount], [data strModDate]];
  }else{
    cell.detailTextLabel.text = [NSString stringWithFormat:@"%@   %@", [data size], [data strModDate]];
  }
  
  if(isDir){
    cell.imageView.image = [UIImage imageNamed:@"folder"];
    cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
  }else{
    switch ([data filetype]) {
      case FileType_TXT:
        cell.imageView.image = [UIImage imageNamed:@"txt"];
        break;
      case FileType_DOC:
        cell.imageView.image = [UIImage imageNamed:@"word"];
        break;
      case FileType_PDF:
        cell.imageView.image = [UIImage imageNamed:@"pdf"];
        break;
      case FileType_PICTURE:
        cell.imageView.image = [UIImage imageNamed:@"picture"];
        break;
      case FileType_MOVIE:
        cell.imageView.image = [UIImage imageNamed:@"movie"];
        break;
      case FileType_MUSIC:
        cell.imageView.image = [UIImage imageNamed:@"music"];
        break;
      case FileType_ZIP:
        cell.imageView.image = [UIImage imageNamed:@"zip"];
        break;
      default:
        cell.imageView.image = [UIImage imageNamed:@"other"];
        break;
    }
    cell.accessoryType = UITableViewCellAccessoryNone;
    
//    UIImage* img=[UIImage imageNamed:@"preview"];
//    UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
//    btn.frame =CGRectMake(0, 0, 36, 36);
//    [btn setBackgroundImage:img forState:UIControlStateNormal];
//    btn.tag = indexPath.row;
//    [btn addTarget: self action: @selector(preViewBtnClick:) forControlEvents: UIControlEventTouchUpInside];
//    cell.accessoryView = btn;
  }
  
  longPress = [[UILongPressGestureRecognizer alloc] initWithTarget:self action:@selector(handleLongPress:)];
  longPress.minimumPressDuration = 1.0; //seconds
  [cell addGestureRecognizer:longPress];
  return cell;
}

-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
  return TABLEVIEW_ROW_HIGHT;
}

//- (void)tableView:(UITableView *)tableView accessoryButtonTappedForRowWithIndexPath:(NSIndexPath *)indexPath
//{
//    NSString *newPath = [self.path stringByAppendingPathComponent:[self.contents[indexPath.row] pathName]];
//    BOOL isDirectory;
//    [[NSFileManager defaultManager ] fileExistsAtPath:newPath isDirectory:&isDirectory];
//    if(!isDirectory){
//      QLPreviewController *previewer = [[QLPreviewController alloc] init];
//      // Set data source
//      [previewer setDataSource:self];
//      curIndex = indexPath.row;
//      [[self navigationController] pushViewController:previewer animated:YES];
//    }
//}

//取消选中时 将存放在self.deleteArr中的数据移除
- (void)tableView:(UITableView *)tableView didDeselectRowAtIndexPath:(NSIndexPath *)indexPath  {
  
  [deleteArr removeObject:[folder getFileInfoOfIndex:indexPath.row]];
}

 //MARK: UITableViewDelegate
- (void)tableView:(UITableView*)tableView didSelectRowAtIndexPath:(NSIndexPath*)indexPath
{
  if(bSelectStatus){
    FileInfoData* data = [folder getFileInfoOfIndex:indexPath.row];
    //data.tag = indexPath.row;
    [deleteArr addObject:data];
    //[deleteArr addObject:[folder getFileInfoOfIndex:indexPath.row]];
    return;
  }
  
  FileInfoData* data = [folder getFileInfoOfIndex:indexPath.row];
  if([data isDir]){
    //[tableView deselectRowAtIndexPath:indexPath animated:YES];
    NSString* path = [folder getPathNameOfIndex:indexPath.row];
    ViewController* vc = [self.storyboard instantiateViewControllerWithIdentifier:@"mainVC"];
    vc.path = path;
    //设置第二个窗口中的delegate为第一个窗口的self
    vc.delegate = self;
    vc.pickerDelegate = _pickerDelegate;
    
    NSString* backName = [self.path lastPathComponent];
    UIBarButtonItem *backItem = [[UIBarButtonItem alloc] initWithTitle:backName style:UIBarButtonItemStylePlain target:nil action:nil];
    [self.navigationItem setBackBarButtonItem:backItem];
    [self.navigationController pushViewController:vc animated:YES];
    return;
  }
  
  //UIButton *button = (UIButton *)sender;
  //NSInteger index = button.tag;
  
  QLPreviewController *previewer = [[QLPreviewController alloc] init];
  // Set data source
  [previewer setDataSource:self];
  curIndex = indexPath.row;
  [[self navigationController] pushViewController:previewer animated:YES];
}

- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
  if (editingStyle == UITableViewCellEditingStyleDelete) {
    [self deleteFile:indexPath];
  }
}

-(UIView *)InitSectionToolBar{
  int startx = 5;
  UIView *headerView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, self.tableView.frame.size.width, 40)];
  [headerView setBackgroundColor:[UIColor colorWithRed:238.0/255.0 green:238.0/255.0 blue:238.0/255.0 alpha:1]];
  
  if([folder getFileCount] == 0){
    [self cancelSelect:nil];
  }
  
  sortButton = [UIButton buttonWithType:UIButtonTypeCustom];
  sortButton.frame = CGRectMake(startx, 5, 100, 30);
  UIImage *sortImg = [UIImage imageNamed:@"sort"];
  [sortButton setImage:sortImg forState:UIControlStateNormal];
  [sortButton setImage:sortImg forState:UIControlStateSelected];
  [sortButton setImage:sortImg forState:UIControlStateHighlighted];
  [sortButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
  [sortButton setTitleColor:[UIColor colorWithRed:0.157 green:0.686 blue:0.973 alpha:1] forState:UIControlStateHighlighted];
  
  if(gSorttype == 0){
    [sortButton setTitle:@"名称排序" forState:UIControlStateNormal];
  }else{
    [sortButton setTitle:@"时间排序" forState:UIControlStateNormal];
  }
  
  sortButton.titleLabel.font = [UIFont systemFontOfSize:16];//title字体大小
  sortButton.backgroundColor = [UIColor clearColor];//colorWithRed:0.157 green:0.686 blue:0.973 alpha:1];
  sortButton.layer.cornerRadius = 4.0;
  
  sortButton.contentHorizontalAlignment = UIControlContentHorizontalAlignmentLeft;
  [sortButton setTitleEdgeInsets:UIEdgeInsetsMake(0, -10, 0, 0)];
  [sortButton setImageEdgeInsets:UIEdgeInsetsMake(1, 75, -1, -75)];
  [sortButton layoutIfNeeded];
  
  [sortButton addTarget:self action:@selector(sortFile:) forControlEvents:UIControlEventTouchUpInside];
  //点击事件
  [sortButton addTarget:self action:@selector(buttonTouchDownClick:) forControlEvents:UIControlEventTouchDown];
  
  [headerView addSubview:sortButton];
  startx += 105;
  
  if(!bSelectStatus){
    
    UIButton* pasterButton = nil;
    
    //新建按钮
    UIButton* createButton = [UIButton buttonWithType:UIButtonTypeCustom];
    createButton.frame = CGRectMake(self.tableView.frame.size.width - 105, 5, 100, 30);

    [createButton setTitle:@"新建文件夹" forState:UIControlStateNormal];
    createButton.titleLabel.font = [UIFont systemFontOfSize:16];//title字体大小

    [createButton setTitleEdgeInsets:UIEdgeInsetsMake(0, 2, 0, 0)]; //4个参数是上边界，左边界，下边界，右边界。
    [createButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    createButton.backgroundColor = [UIColor clearColor];//colorWithRed:0.157 green:0.686 blue:0.973 alpha:1];
    createButton.layer.cornerRadius = 4.0;
   
    [createButton addTarget:self action:@selector(addFolder:) forControlEvents:UIControlEventTouchUpInside];
    [createButton addTarget:self action:@selector(buttonTouchDownClick:) forControlEvents:UIControlEventTouchDown];
    [headerView addSubview:createButton];
    
    if([folder getFileCount] > 0){
      //多选按钮
      UIButton* selectButton = [UIButton buttonWithType:UIButtonTypeCustom];
    
      NSInteger optype;
      if(![folder getOrgFileOperate: &optype]){
        startx = (self.tableView.frame.size.width - 80) / 2;
      }else{
        startx += (self.tableView.frame.size.width - 200 - 160) / 3 - 2;
      }

      selectButton.frame = CGRectMake(startx, 5, 80, 30);
      [selectButton setTitle:@"多选" forState:UIControlStateNormal];
      selectButton.titleLabel.font = [UIFont systemFontOfSize:16];//title字体大小
      
      [selectButton setTitleEdgeInsets:UIEdgeInsetsMake(0, 2, 0, 0)]; //4个参数是上边界，左边界，下边界，右边界。
      [selectButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
        
      selectButton.backgroundColor = [UIColor clearColor];//colorWithRed:0.157 green:0.686 blue:0.973 alpha:1];
      selectButton.layer.cornerRadius = 4.0;
      //pasterButton.layer.borderWidth = 1.0f;
      
      [selectButton addTarget:self action:@selector(select:) forControlEvents:UIControlEventTouchUpInside];
      [selectButton addTarget:self action:@selector(buttonTouchDownClick:) forControlEvents:UIControlEventTouchDown];
      [headerView addSubview:selectButton];
      startx += 75;
    }
    
    //粘贴按钮
    NSInteger optype;
    if([folder getOrgFileOperate: &optype]){
      if([folder getFileCount] == 0){
        startx = (self.tableView.frame.size.width - 80) / 2;
      }else{
        startx += (self.tableView.frame.size.width - 200 - 160) / 3 - 3;
      }
      
      pasterButton = [UIButton buttonWithType:UIButtonTypeCustom];
      pasterButton.frame = CGRectMake(startx, 5, 80, 30);
       
      [pasterButton setTitle:@"粘贴" forState:UIControlStateNormal];
      pasterButton.titleLabel.font = [UIFont systemFontOfSize:16];//title字体大小
      
      [pasterButton setTitleEdgeInsets:UIEdgeInsetsMake(0, 2, 0, 0)]; //4个参数是上边界，左边界，下边界，右边界。
      [pasterButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
        
      pasterButton.backgroundColor = [UIColor clearColor];//colorWithRed:0.157 green:0.686 blue:0.973 alpha:1];
      pasterButton.layer.cornerRadius = 4.0;
        
      [pasterButton addTarget:self action:@selector(paste:) forControlEvents:UIControlEventTouchUpInside];
      [pasterButton addTarget:self action:@selector(buttonTouchDownClick:) forControlEvents:UIControlEventTouchDown];
      [headerView addSubview:pasterButton];
    }
    
    if(baseView != nil){
      [baseView removeFromSuperview];
      baseView = nil;
    }
    
    UIEdgeInsets insets = self.tableView.contentInset;
    self.tableView.contentInset = UIEdgeInsetsMake(insets.top, insets.left, 0, insets.right);
    return headerView;
  }
  
  
  //全选按钮
  UIButton* selectButton = [UIButton buttonWithType:UIButtonTypeCustom];
  selectButton.frame = CGRectMake((self.tableView.frame.size.width - 80) / 2, 5, 80, 30);
  [selectButton setTitle:@"全选" forState:UIControlStateNormal];
  selectButton.titleLabel.font = [UIFont systemFontOfSize:16];//title字体大小
    
  [selectButton setTitleEdgeInsets:UIEdgeInsetsMake(0, 2, 0, 0)]; //4个参数是上边界，左边界，下边界，右边界。
  [selectButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];

  selectButton.backgroundColor = [UIColor clearColor];//colorWithRed:0.157 green:0.686 blue:0.973 alpha:1];
  selectButton.layer.cornerRadius = 4.0;
  //pasterButton.layer.borderWidth = 1.0f;

  [selectButton addTarget:self action:@selector(selectAllCell:) forControlEvents:UIControlEventTouchUpInside];
  [selectButton addTarget:self action:@selector(buttonTouchDownClick:) forControlEvents:UIControlEventTouchDown];
  
  [headerView addSubview:selectButton];
  
  
  //完成按钮
  UIButton* completeButton = [UIButton buttonWithType:UIButtonTypeCustom];
  completeButton.frame = CGRectMake(self.tableView.frame.size.width - 90, 5, 80, 30);
  
  [completeButton setTitle:@"返回" forState:UIControlStateNormal];
  completeButton.titleLabel.font = [UIFont systemFontOfSize:16];//title字体大小
  
  [completeButton setTitleEdgeInsets:UIEdgeInsetsMake(0, 2, 0, 0)]; //4个参数是上边界，左边界，下边界，右边界。
  [completeButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
  
  completeButton.backgroundColor = [UIColor clearColor];//colorWithRed:0.157 green:0.686 blue:0.973 alpha:1];
  completeButton.layer.cornerRadius = 4.0;
  
  [completeButton addTarget:self action:@selector(cancelSelect:) forControlEvents:UIControlEventTouchUpInside];
  [completeButton addTarget:self action:@selector(buttonTouchDownClick:) forControlEvents:UIControlEventTouchDown];
  
  [headerView addSubview:completeButton];
  
  if(baseView != nil){
    [baseView removeFromSuperview];
  }
  
  baseView = [[UIView alloc] initWithFrame:CGRectMake(0, self.view.frame.size.height - 60, self.view.frame.size.width, 60)];
  baseView.backgroundColor = [UIColor grayColor];
  [self.view addSubview:baseView];
  
  //删除按钮
  UIButton* deleteButton = [UIButton buttonWithType:UIButtonTypeCustom];
  deleteButton.backgroundColor = [UIColor redColor];
  [deleteButton setTitle:@"删除" forState:UIControlStateNormal];
  deleteButton.frame = CGRectMake(0, 0, self.view.frame.size.width, 60);
  [deleteButton addTarget:self action:@selector(deleteClick:) forControlEvents:UIControlEventTouchUpInside];
  [baseView addSubview:deleteButton];
  
  CGRect frame = self.tableView.frame;
  NSUInteger count = [folder getFileCount];
  if(count * TABLEVIEW_ROW_HIGHT + 40 > frame.size.height - 50 - 60){
    UIEdgeInsets insets = self.tableView.contentInset;
    self.tableView.contentInset = UIEdgeInsetsMake(insets.top, insets.left, insets.bottom + 60, insets.right);
  }
  return headerView;
}

//方法如下：
- (UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section {
//  UIView *headerView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, tableView.frame.size.width, 30)];
//  UILabel *label = [[UILabel alloc] initWithFrame:CGRectMake(5, 5, tableView.frame.size.width, 20)];
//  label.font = [UIFont systemFontOfSize:14.0f];  //UILabel的字体大小
//  label.numberOfLines = 1;  //必须定义这个属性，否则UILabel不会换行
//  label.textColor = [UIColor whiteColor];
//  label.textAlignment = NSTextAlignmentLeft;  //文本对齐方式
//  [label setBackgroundColor:[UIColor clearColor]];
// 
//  [headerView setBackgroundColor:[UIColor lightGrayColor]];
//  [headerView addSubview:label];
//  
//  NSRange range;
//  range = [self.path rangeOfString:gFirstpath];
//  if(range.location != NSNotFound) {
//    label.text = [NSString stringWithFormat:@"[%@]", [self.path substringFromIndex:range.location]];
//  }
  return [self InitSectionToolBar];
}

-(UITableViewCellEditingStyle)tableView:(UITableView*)tableView editingStyleForRowAtIndexPath:(NSIndexPath*)indexPath {
  return UITableViewCellEditingStyleDelete;
}

////别忘了设置高度
//- (CGFloat) tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section
//{
//  return 30.0f;
//}

//    //MARK: UITableViewDataSource
//- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
//    return [self.contents count];
//}
//
//- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
//    
//    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"tableCell"];
//    NSString* fileName = [self.contents objectAtIndex:indexPath.row];
//    cell.textLabel.text = fileName;
//    
//    
//    if ([self isDirectoryAtIndexPath:indexPath]) {
//        cell.imageView.image = [UIImage imageNamed:@"folder.png"];
//        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
//    } else {
//        cell.imageView.image = [UIImage imageNamed:@"file.png"];
//        cell.accessoryType = UITableViewCellAccessoryNone;
//    }
//    
//    longPress = [[UILongPressGestureRecognizer alloc]
//                                          initWithTarget:self action:@selector(handleLongPress:)];
//    longPress.minimumPressDuration = 1.0; //seconds
//    [cell addGestureRecognizer:longPress];
//
//    return cell;
//}

//    //MARK: UITableViewDelegate
//- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
//    
//    [tableView deselectRowAtIndexPath:indexPath animated:YES];
//    NSString* fileName = [self.contents objectAtIndex:indexPath.row];
//    NSString* path = [self.path stringByAppendingPathComponent:fileName];
//    if ([self isDirectoryAtIndexPath:indexPath]) {
//        ViewController* vc = [self.storyboard instantiateViewControllerWithIdentifier:@"mainVC"];
//        vc.path = path;
//        [self.navigationController pushViewController:vc animated:YES];
//    }
//}

#pragma mark - QuickLook

- (BOOL)previewController:(QLPreviewController *)controller shouldOpenURL:(NSURL *)url forPreviewItem:(id <QLPreviewItem>)item {
  return YES;
}

- (NSInteger) numberOfPreviewItemsInPreviewController: (QLPreviewController *) controller {
  return 1;
}

- (id <QLPreviewItem>) previewController: (QLPreviewController *) controller
                      previewItemAtIndex: (NSInteger) index {
  NSString *newPath = [folder getPathNameOfIndex:curIndex];
  return [NSURL fileURLWithPath:newPath];
}

@end

