//
//  FileBrowserPlugin.m
//
//  Created by leeh on 16/9/2.
//  Copyright © 2016年  lihong. All rights reserved.
//

#import "FileBrowserPlugin.h"
#import "ViewController.h"
#import "FileChooseViewController.h"
#import "NSFileManager-Utilities.h"
#import "TZImagePickerController.h"
#import "TZImageManager.h"

@interface FileBrowserPlugin ()<UIImagePickerControllerDelegate,UINavigationControllerDelegate, UIActionSheetDelegate>{
  UIStoryboard *storyboard;
  NSString* retCaption;
  NSUInteger maxCount;
  NSUInteger imgWidth;
  NSUInteger imgHeight;
}
@end

@implementation FileBrowserPlugin

static UIButton *_progressHUD;
static UIView *_HUDContainer;
static UIActivityIndicatorView *_HUDIndicatorView;
static UILabel *_HUDLable;

+ (void)showProgressHUD:(NSInteger)timeout {
  if (!_progressHUD) {
    _progressHUD = [UIButton buttonWithType:UIButtonTypeCustom];
    [_progressHUD setBackgroundColor:[UIColor clearColor]];
    
    _HUDContainer = [[UIView alloc] init];
    _HUDContainer.frame = CGRectMake(([UIScreen mainScreen].bounds.size.width - 120) / 2, ([UIScreen mainScreen].bounds.size.height - 90) / 2, 120, 90);
    _HUDContainer.layer.cornerRadius = 8;
    _HUDContainer.clipsToBounds = YES;
    _HUDContainer.backgroundColor = [UIColor darkGrayColor];
    _HUDContainer.alpha = 0.7;
    
    _HUDIndicatorView = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhite];
    _HUDIndicatorView.frame = CGRectMake(45, 15, 30, 30);
    
    _HUDLable = [[UILabel alloc] init];
    _HUDLable.frame = CGRectMake(0,40, 120, 50);
    _HUDLable.textAlignment = NSTextAlignmentCenter;
    _HUDLable.text = @"正在处理...";
    _HUDLable.font = [UIFont systemFontOfSize:15];
    _HUDLable.textColor = [UIColor whiteColor];
    
    [_HUDContainer addSubview:_HUDLable];
    [_HUDContainer addSubview:_HUDIndicatorView];
    [_progressHUD addSubview:_HUDContainer];
  }
  [_HUDIndicatorView startAnimating];
  [[UIApplication sharedApplication].keyWindow addSubview:_progressHUD];
  
  // if over time, dismiss HUD automatic
  dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(timeout * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
    [FileBrowserPlugin hideProgressHUD];
  });
}

+ (void)hideProgressHUD {
  if (_progressHUD) {
    [_HUDIndicatorView stopAnimating];
    [_progressHUD removeFromSuperview];
  }
}

+ (void)showAlertWithTitle:(UIViewController*)vc title:(NSString *)title {
  if (iOS8Later) {
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:title message:nil preferredStyle:UIAlertControllerStyleAlert];
    [alertController addAction:[UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:nil]];
    [vc presentViewController:alertController animated:YES completion:nil];
  } else {
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wdeprecated-declarations"
    [[[UIAlertView alloc] initWithTitle:title message:nil delegate:nil cancelButtonTitle:@"确定" otherButtonTitles:nil, nil] show];
#pragma clang diagnostic pop
  }
}

- (void)pluginInitialize{
//    dispatch_async(dispatch_get_main_queue(), ^{
//        NSLog(@"home directory:%@", NSHomeDirectory());
//        NSFileManager *fileManager = [NSFileManager defaultManager];
//        NSError *error;
//        NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
//        NSString *documentsDirectory = [paths objectAtIndex:0];
//        
//        NSString *txtPath = [documentsDirectory stringByAppendingPathComponent:@"docSample.docx"];
//        
//        if ([fileManager fileExistsAtPath:txtPath] == NO) {
//            NSString *resourcePath = [[NSBundle mainBundle] pathForResource:@"docSample" ofType:@"docx"];
//            [fileManager copyItemAtPath:resourcePath toPath:txtPath error:&error];
//        }
//        
//        txtPath = [documentsDirectory stringByAppendingPathComponent:@"pngSample.png"];
//        
//        if ([fileManager fileExistsAtPath:txtPath] == NO) {
//            NSString *resourcePath = [[NSBundle mainBundle] pathForResource:@"pngSample" ofType:@"png"];
//            [fileManager copyItemAtPath:resourcePath toPath:txtPath error:&error];
//            
//            txtPath = [[txtPath stringByDeletingLastPathComponent] stringByAppendingPathComponent:@"pngSampletest1.png"];
//            [fileManager copyItemAtPath:resourcePath toPath:txtPath error:&error];
//            
//            txtPath = [[txtPath stringByDeletingLastPathComponent] stringByAppendingPathComponent:@"pngSampletest2.png"];
//            [fileManager copyItemAtPath:resourcePath toPath:txtPath error:&error];
//        }
//        
//        txtPath = [documentsDirectory stringByAppendingPathComponent:@"pngSample1.png"];
//        
//        if ([fileManager fileExistsAtPath:txtPath] == NO) {
//            NSString *resourcePath = [[NSBundle mainBundle] pathForResource:@"pngSample1" ofType:@"png"];
//            [fileManager copyItemAtPath:resourcePath toPath:txtPath error:&error];
//            
//            txtPath = [[txtPath stringByDeletingLastPathComponent] stringByAppendingPathComponent:@"pngSampletest3.png"];
//            [fileManager copyItemAtPath:resourcePath toPath:txtPath error:&error];
//            
//            txtPath = [[txtPath stringByDeletingLastPathComponent] stringByAppendingPathComponent:@"pngSampletest4.png"];
//            [fileManager copyItemAtPath:resourcePath toPath:txtPath error:&error];
//        }
//        
//        txtPath = [documentsDirectory stringByAppendingPathComponent:@"txtSample.txt"];
//        
//        if ([fileManager fileExistsAtPath:txtPath] == NO) {
//            NSString *resourcePath = [[NSBundle mainBundle] pathForResource:@"txtSample" ofType:@"txt"];
//            [fileManager copyItemAtPath:resourcePath toPath:txtPath error:&error];
//        }
//    });
    
    NSString *storyboardName =@"filebrowser";
    storyboard = [UIStoryboard  storyboardWithName:storyboardName bundle:nil];
    retCaption = nil;
    maxCount = 9;
    imgWidth = 800;
    imgHeight = 600;
  
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
      [self deleteTmpFile];
    });
}

- (void)open:(CDVInvokedUrlCommand*)command{
  self.callbackID = command.callbackId;
  ViewController* viewcontroller = [storyboard instantiateViewControllerWithIdentifier:@"mainVC"];
  viewcontroller.pickerDelegate = self;
  if(command.arguments.count > 0){
    NSDictionary *options = [command.arguments objectAtIndex: 0];
    retCaption = [options objectForKey:@"exitCaption"];
    if(retCaption && retCaption.length > 0){
      viewcontroller.retLabelTitle = retCaption;
    }
  }
  UINavigationController* fbNavViewController = [[UINavigationController alloc] initWithRootViewController:viewcontroller];
  fbNavViewController.modalPresentationStyle = UIModalPresentationFullScreen;
  [self.viewController presentViewController:fbNavViewController animated:YES completion:nil];
}

- (void)select:(CDVInvokedUrlCommand *)command{
  self.callbackID = command.callbackId;
//  type:
//  image/*,doc/-:拍照,
//  image/*:拍照、图库, 
//  video/*,doc/-:摄像,
//  image/*,video/*;doc/-:拍照、摄像,
//  image/*,video/*:拍照、摄像、图库,
//  audio/*,doc/-:录音,
//  audio/*:录音、文档,
//*/*:全部
  
  dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
    [self deleteTmpFile];
  });
  
  if(command.arguments.count > 0){
    NSDictionary *options = [command.arguments objectAtIndex: 0];
    NSString* type = [options objectForKey:@"type"];
    if(type == nil){
      return;
    }
    
    NSArray *aArray = [type componentsSeparatedByString:@";"];
    if([aArray count] == 0){
      return;
    }
    
    retCaption = [options objectForKey:@"exitCaption"];
    maxCount = [[options objectForKey:@"maxSelectCount"] integerValue];
    NSInteger width = [[options objectForKey:@"width"] integerValue];
    NSInteger heigh = [[options objectForKey:@"height"] integerValue];
    if(width > 0){
      imgWidth = width;
    }
    
    if(heigh > 0){
      imgHeight = heigh;
    }
    
    UIActionSheet *myActionSheet = [[UIActionSheet alloc] initWithTitle:nil delegate:self cancelButtonTitle:@"取消" destructiveButtonTitle:nil otherButtonTitles:nil, nil];
    
    NSUInteger count = [aArray count];
    for(int i = 0; i < count; i++){//NSString* item in aArray){
      NSString* item = aArray[i];
      
      if([item isEqualToString:@"image/*"]){
        if(i + 1 < count && [aArray[i + 1] isEqualToString:@"doc/-"]){
          [myActionSheet addButtonWithTitle:@"拍照"];
        }else{
          [myActionSheet addButtonWithTitle:@"相册"];
        }
        continue;
      }
      
      if([item isEqualToString:@"video/*"]){
        if(i + 1 < count && [aArray[i + 1] isEqualToString:@"doc/-"]){
          [myActionSheet addButtonWithTitle:@"录像"];
        }else{
          [myActionSheet addButtonWithTitle:@"相册"];
        }
        continue;
      }
      
      if([item isEqualToString:@"*/*"]){
        [myActionSheet addButtonWithTitle:@"全部文件"];
        continue;
      }
    }
    [myActionSheet showInView:self.viewController.view];
  }
}

- (void)selected:(NSArray *)info {
  [self.viewController dismissViewControllerAnimated:YES completion:nil];
  if(info){
    CDVPluginResult* pluginResult = nil;
    NSMutableArray *resultStrings = [[NSMutableArray alloc] init];
    for(NSString* filePath in info){
      [resultStrings addObject:[[NSURL fileURLWithPath:filePath] absoluteString]];
    }

    pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsArray:resultStrings];
    [self.commandDelegate sendPluginResult:pluginResult callbackId:self.callbackID];
  }
}

- (void)cancelSelect {
    [self.viewController dismissViewControllerAnimated:YES completion:nil];
    CDVPluginResult* pluginResult = nil;
    NSArray* emptyArray = [NSArray array];
    pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsArray:emptyArray];
    [self.commandDelegate sendPluginResult:pluginResult callbackId:self.callbackID];
}

- (void) takePicture {
  UIImagePickerController *picker = [[UIImagePickerController alloc] init];
  if([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]) {
    picker.sourceType = UIImagePickerControllerSourceTypeCamera;
    picker.mediaTypes = @[@"public.image"];
    picker.delegate = self;
  }
  [self.viewController presentViewController:picker animated:YES completion:nil];
}

- (void) takeMovie {
  UIImagePickerController *picker = [[UIImagePickerController alloc] init];
  if([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]) {
    picker.sourceType = UIImagePickerControllerSourceTypeCamera;
    //Camera所支持的Media格式都有哪些,共有两个分别是@"public.image",@"public.movie"
    picker.mediaTypes = @[@"public.movie"];
    picker.videoMaximumDuration = 30.0f;//30秒
    picker.delegate = self;
  }
  [self.viewController presentViewController:picker animated:YES completion:nil];
}

-(void)deleteTmpFile{
  NSFileManager *fileManager = [NSFileManager defaultManager];
  NSString* path = NSTemporaryDirectory();
  NSDirectoryEnumerator *dirEnum = [fileManager enumeratorAtPath:path];
  NSString *file;
  while(file = [dirEnum nextObject]){
    NSError* error;
    NSString *newPath = [path stringByAppendingPathComponent:file];
    if([file containsString:@"MediaCache"] || [file containsString:@"capture"]){
      [fileManager removeItemAtPath:newPath error:&error];
      continue;
    }
    
    NSDictionary* fileAttributes = [fileManager attributesOfItemAtPath:newPath error:&error];
    if(fileAttributes != nil) {
      NSDate* modDate = [fileAttributes objectForKey:NSFileModificationDate];
      
      double intervalTime = [[NSDate date] timeIntervalSinceReferenceDate] - [modDate timeIntervalSinceReferenceDate];
      //超过3个小时就删除
      if(intervalTime > 180 * 60.0){
         [fileManager removeItemAtPath:newPath error:&error];
      }
    }
  }
}

- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info
{
  NSString *mediaType = [info objectForKey:UIImagePickerControllerMediaType];
  BOOL success;
  NSFileManager *fileManager = [NSFileManager defaultManager];
  NSError *error;
  NSString *documentsDirectory = [NSTemporaryDirectory() stringByStandardizingPath];
  NSString *mediaFile;
  
  if([mediaType isEqualToString:@"public.image"]){
    [FileBrowserPlugin showProgressHUD:60];
    UIImage *image = [info objectForKey:@"UIImagePickerControllerOriginalImage"];
    image = [TZImageManager scaleImage:image toSize:CGSizeMake(imgWidth, imgHeight)];
    
    mediaFile = [documentsDirectory stringByAppendingPathComponent:@"temp.jpg"];
    success = [fileManager fileExistsAtPath:mediaFile];
    if(success) {
      success = [fileManager removeItemAtPath:mediaFile error:&error];
    }
    
    NSData* data = UIImageJPEGRepresentation(image, 1.0f);
    success = [data writeToFile:mediaFile atomically:YES];
    
    [picker dismissViewControllerAnimated:YES completion:nil];
    
    CDVPluginResult* pluginResult = nil;
    NSMutableArray *resultStrings = [[NSMutableArray alloc] init];
    [resultStrings addObject:[[NSURL fileURLWithPath:mediaFile] absoluteString]];
    [FileBrowserPlugin hideProgressHUD];
    
    pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsArray:resultStrings];
    [self.commandDelegate sendPluginResult:pluginResult callbackId:self.callbackID];
    return;
  }
  
  if([mediaType isEqualToString:@"public.movie"]){
    //[FileBrowserPlugin showProgressHUD:360];
    NSURL *url = [info objectForKey:UIImagePickerControllerMediaURL];
    CDVPluginResult* pluginResult = nil;
    NSMutableArray *resultStrings = [[NSMutableArray alloc] init];
    [resultStrings addObject:[url absoluteString]];
    pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsArray:resultStrings];
    [self.commandDelegate sendPluginResult:pluginResult callbackId:self.callbackID];
    [picker dismissViewControllerAnimated:YES completion:nil];
    return;
    
    /*
    NSString* name = [[url path] lastPathComponent];
    mediaFile = [documentsDirectory stringByAppendingPathComponent:@"temp.mp4"];
    BOOL success = [fileManager fileExistsAtPath:mediaFile];
    if(success) {
      success = [fileManager removeItemAtPath:mediaFile error:&error];
    }
    
    AVURLAsset *avAsset = [AVURLAsset URLAssetWithURL:url options:nil];
    AVAssetExportSession *exportSession = [[AVAssetExportSession alloc] initWithAsset:avAsset presetName:AVAssetExportPresetMediumQuality];
    exportSession.outputURL = [NSURL fileURLWithPath:mediaFile];
    exportSession.outputFileType = AVFileTypeMPEG4;
    exportSession.shouldOptimizeForNetworkUse= YES;
    [exportSession exportAsynchronouslyWithCompletionHandler:^(void){
      if(exportSession.status == AVAssetExportSessionStatusCompleted){
        [self deleteTmpFile];
        [FileBrowserPlugin hideProgressHUD];
        CDVPluginResult* pluginResult = nil;
        NSMutableArray *resultStrings = [[NSMutableArray alloc] init];
        [resultStrings addObject:[[NSURL fileURLWithPath:mediaFile] absoluteString]];
        pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsArray:resultStrings];
        [self.commandDelegate sendPluginResult:pluginResult callbackId:self.callbackID];
        return;
      }
      
      if(exportSession.status == AVAssetExportSessionStatusUnknown
         || exportSession.status == AVAssetExportSessionStatusFailed
         || exportSession.status == AVAssetExportSessionStatusCancelled){
        [self deleteTmpFile];
        [FileBrowserPlugin hideProgressHUD];
        [FileBrowserPlugin showAlertWithTitle:self.viewController title:@"保存视频失败"];
      }
    }];
    [picker dismissViewControllerAnimated:YES completion:nil];*/
  }
}

- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker {
  [picker dismissViewControllerAnimated:YES completion:nil];
 
  CDVPluginResult* pluginResult = nil;
  NSArray* emptyArray = [NSArray array];
  pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsArray:emptyArray];
  [self.commandDelegate sendPluginResult:pluginResult callbackId:self.callbackID];
}

- (void)selectImageVideo{
  TZImagePickerController *imagePickerVc = [[TZImagePickerController alloc] initWithMaxImagesCount:maxCount delegate:nil];
  imagePickerVc.plugPickerDelegate = self;
  imagePickerVc.retLabelTitle = retCaption;
  [self.viewController presentViewController:imagePickerVc animated:YES completion:nil];
}

- (void)actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex{
  NSString* title = [actionSheet buttonTitleAtIndex:buttonIndex];
  if([title isEqualToString:@"拍照"]){
    [self takePicture];
    return;
  }
  
  if([title isEqualToString:@"相册"]){
    [self selectImageVideo];
    return;
  }
  
  if([title isEqualToString:@"录像"]){
    [self takeMovie];
    return;
  }
  
  if([title isEqualToString:@"全部文件"]){
    NSString* path = NSDocumentsFolder();
    FileChooseViewController* vc = [[FileChooseViewController alloc] initWithPath:path
                                                                        parentDir:@""];
    vc.pickerDelegate = self;
    if(retCaption && retCaption.length > 0){
      vc.retLabelTitle = retCaption;
    }

    if(maxCount > 0){
      vc.maxSelectCount = maxCount;
    }
    
    UINavigationController* fbNavViewController = [[UINavigationController alloc] initWithRootViewController:vc];
    fbNavViewController.modalPresentationStyle = UIModalPresentationFullScreen;
    [self.viewController presentViewController:fbNavViewController animated:YES completion:nil];
    return;
  }
}
@end
